#############################
#
#          SoloCartes
#
# Copyright 2008 Newmagic
#
#    This file is part of SoloCartes.
#
#    You can redistribute and/or modify
#    this software under the terms of the
#    Creative Commons  Attribution-NonCommercial-ShareAlike 3.0 Legal Code
#
#    See COPYING file(s) join to the distribution and/or
#    http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
#
#############################

global PARAM

set PARAM(rep) [info script]
set PARAM(rep) [file dirname $PARAM(rep)]
cd $PARAM(rep)

source "SoloCartes_initJeux.tcl"

global nbCartesDistrib
set nbCartesDistrib 2

global LISTE_VARS_OPTIONS_JEU
set LISTE_VARS_OPTIONS_JEU [list nbCartesDistrib]

global LISTE_VARS_SAUV_PARTIE
set LISTE_VARS_SAUV_PARTIE [list paquet depots nbPassagesPaquet indDerniereCarteDistribuee nbCartes nbCartesDistrib]

global jeuCourant
set jeuCourant Familles
chargerOptionsJeu

array set imagesFaces [list]


proc depotSousXY {x y} {
  return [depotSousPourcXY [pourcCoordX $x] [pourcCoordY $y]]
}

proc depotSousPourcXY {pourcX pourcY} {
  global depots
  global largImages
  global PAQUET_POURC_Y
  global hautImages

#  if {$pourcY >= [expr {$PAQUET_POURC_Y * 2 + $hautImages}]}
  if {$pourcY < $PAQUET_POURC_Y} {
    set continuer true
    set i 0
    set minCarte $pourcX
#    set maxCarte [expr {$pourcX + [pourcCoordX $largImages]}]
    set maxCarte [expr {$pourcX + $largImages}]
    set milieuCarte [expr {$minCarte + (($maxCarte - $minCarte) / 2)}]
    set colDroite -1
    set colGauche -1
    set distGauche -1
    set distDroite -1

#msgBox "$pourcX [pourcCoordX $largImages] => $milieuCarte"
    while {$continuer} {
      incr i
      if {$i <= 4} {
        set minCol $depots($i,posX)
        if {$minCol > $maxCarte} {
          # ca sert  rien d'aller + loin
          set continuer false
        }
        if {$continuer} {
#          set maxCol [expr {$minCol + [pourcCoordX $largImages]}]
          set maxCol [expr {$minCol + $largImages}]
          if {$minCarte >= $minCol && $minCarte <= $maxCol} {
            set colGauche $i
#            set distGauche [expr {$maxCol - $minCarte}]
            set distGauche [expr {$maxCarte - $minCol}]
          }
          if {$maxCarte >= $minCol && $maxCarte <= $maxCol} {
            set colDroite $i
#            set distDroite [expr {$maxCarte - $minCol}]
            set distDroite [expr {$maxCol - $minCarte}]
          }
        }
      } else {
        set continuer false
      }
    }
    set indCol $colGauche
    if {$colGauche > 0 && $colDroite > 0} {
      # on regarde le plus prs :
      if {$distGauche > $distDroite} {
        set indCol $colDroite
      }
    }
    if {$indCol == -1} {
      set indCol $colDroite
    }
    return $indCol
  } else {
    return -1
  }
}

global paquet


global depots
set depots(ind,posX) pourc
set depots(ind,listeCartes) [list]

global nbPassagesPaquet
set nbPassagesPaquet 0

proc attraperCarte {indCarte x y} {
  global indCarteDragguee
  global indCarteDraggueeTmp
  global diffX
  global diffY
  global imgCartes
  global paquet
  global x_initDrag
  global y_initDrag
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global largImages
  global indDerniereCarteDistribuee
  global nbCartes
  global nbCartesDistrib
  global nbPassagesPaquet

  set liste [.frmJeu.cnv coords $imgCartes($indCarte)]
  set x_carte [lindex $liste 0]
  set y_carte [lindex $liste 1]
  if {$paquet($indCarte,distribuee)} {
#    if {$paquet($indCarte,faceEnHaut)} {
      if {(! [carteSurDepot $indCarte]) && $indCarte == $indDerniereCarteDistribuee} {
        set indCarteDraggueeTmp $indCarte
        .frmJeu.cnv raise Carte$indCarteDraggueeTmp
        set x_initDrag $x_carte
        set y_initDrag $y_carte
        set diffX [expr {$x - $x_initDrag}]
        set diffY [expr {$y - $y_initDrag}]
}
#    }
  } else {
    if {[pourcCoordX $x_carte] == $PAQUET_POURC_X && [pourcCoordY $y_carte] == $PAQUET_POURC_Y} {
      # clic sur paquet
memoriserCoupAnnuler 1
distribuer
    }
  }
}

proc distribuer {{jusqua ""}} {
  global indDerniereCarteDistribuee
  global paquet
  global nbCartesDistrib
  global nbCartes
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global largImages
  global imgCartes
  
  if {$jusqua == ""} {
    set jusqua $nbCartes
  }
  if {$indDerniereCarteDistribuee <= 0} {
    set indDerniereCarteDistribuee 1 ;# on passe direct  la 1
  } else {
    set i 1
    set prec $indDerniereCarteDistribuee
    #incr prec -1
    set prec [cartePrecDistribuee $prec]
    while {$i < $nbCartesDistrib && $prec > 0} {
      .frmJeu.cnv coords $imgCartes($prec) [list [coordX [expr {$PAQUET_POURC_X + $largImages + 5}]] [coordY $PAQUET_POURC_Y]]
      incr i
      incr prec -1
      set prec [cartePrecDistribuee $prec]
    }
  }
  for {set i 0} {$i < $nbCartesDistrib} {incr i} {
    set continuer true
    while {$continuer} {
      if {$indDerniereCarteDistribuee <= $jusqua} {
        if {$indDerniereCarteDistribuee > 0} {
          if {! $paquet($indDerniereCarteDistribuee,distribuee)} {
            set indCarte $indDerniereCarteDistribuee
            set paquet($indCarte,faceEnHaut) false
            deplacerCarte $indCarte [coordX [expr {$PAQUET_POURC_X + $largImages + 5 + 2 * $i}]] [coordY $PAQUET_POURC_Y]
            retournerCarte $indCarte
            set paquet($indCarte,distribuee) true
            set continuer false
          } else {
            incr indDerniereCarteDistribuee
          }
        } else {
          set continuer false
        }
      } else {
        set indDerniereCarteDistribuee $jusqua
        set continuer false
      }
    }
  }
}

proc lacherCarte {} {
  global indCarteDragguee
  global indCarteDraggueeTmp
  global imgCartes
  global diffX
  global diffY
  global x_initDrag
  global y_initDrag
  global paquet
  global depots
  global indDerniereCarteDistribuee

  set diffX 0
  set diffY 0
  if {$indCarteDraggueeTmp > 0} {
    set indCarteDragguee $indCarteDraggueeTmp
    set deplaceOk false
    set indCarte $indCarteDragguee
    set liste [.frmJeu.cnv coords $imgCartes($indCarte)]
    set x [lindex $liste 0]
    set y [lindex $liste 1]

    # on tente le dpt
    set indDepot [depotSousXY $x $y]
#msgBox "$indDepot"
    if {$indDepot > 0} {
      set deplaceOk [essayeDeplaceSurDepot $indCarte $indDepot $x_initDrag $y_initDrag]
    }

    if {!$deplaceOk} {
      # on la replace o elle tait
      deplacerCarteDraguee $x_initDrag $y_initDrag
    } else {
      if {$indCarte == $indDerniereCarteDistribuee} {
        set indDerniereCarteDistribuee [cartePrecDistribuee $indCarte]
      }
    }
  }
  set indCarteDragguee -1
  set indCarteDraggueeTmp -1
}

proc essayeDeplaceSurDepot {indCarte indDepot {x_initDrag ""} {y_initDrag ""}} {
  global depots
  global paquet
  global colonnes
  global typeScore
  global imgCartes
  
  if {$x_initDrag == "" || $y_initDrag == ""} {
    # On rcupre les coordonnes de la carte :
    set liste [.frmJeu.cnv coords $imgCartes($indCarte)]
    set x_initDrag [lindex $liste 0]
    set y_initDrag [lindex $liste 1]
    
  }
      set reglesOk false
        set deplaceOk false
      set nbCartesSurDepot [llength $depots($indDepot,listeCartes)]
      if {$nbCartesSurDepot > 0} {
        set derniereCarteDepot [lindex $depots($indDepot,listeCartes) end]
        set diff [differenceCartes $derniereCarteDepot $indCarte]
        if {($diff == -1 || $diff == 1) && [famillePCKT $derniereCarteDepot] == [famillePCKT $indCarte]} {
          # -1 et mme famille => ok
          set reglesOk true
        }
      } else {
        set val [string range $paquet($indCarte) 0 0]
        if {$val == "A" || $val == "R"} {
          # as ou roi => ok si la famille n'a pas dj t pose :
          set dejaPrise false
          for {set i 1} {$i <= 4} {incr i} {
            if {[famillePCKT [lindex $depots($i,listeCartes) 0]] == [famillePCKT $indCarte]} {
              set dejaPrise true
            }
          }
          if {! $dejaPrise} {
            set reglesOk true
          }
        }
      }
      if {$reglesOk} {
        # On la place sur le dpt :
#        set indAncienDepot [depotSousXY $x_initDrag $y_initDrag]
#        if {$indAncienDepot > 0} {
#          enleverDerniereCarteDepot $indAncienDepot
#        }
memoriserCoupAnnuler 1
        distribuerCarteSurDepot $indCarte $indDepot
        set deplaceOk true
      }
      return $deplaceOk
}

proc deplacerCarteDraguee {x y} {
  global indCarteDragguee
  global indCarteDraggueeTmp
  global x_initDrag
  global y_initDrag
  global paquet

  if {$indCarteDragguee > 0} {
    deplacerCarte $indCarteDragguee $x $y
  } else {
    set diffX [expr {$x - $x_initDrag}]
    if {$diffX < 0} {set diffX [expr {0 - $diffX}]}
    set diffY [expr {$y - $y_initDrag}]
    if {$diffY < 0} {set diffY [expr {0 - $diffY}]}
    set diffActive 50
    #msgBox "$diffX $diffY"
    if {$diffX > $diffActive || $diffY > $diffActive} {
      set indCarteDragguee $indCarteDraggueeTmp
    }
  }
}


proc bindingsCarte {indCarte} {
  global imgCartes

  .frmJeu.cnv bind $imgCartes($indCarte) <ButtonPress-1> "attraperCarte $indCarte %X %Y"
  .frmJeu.cnv bind $imgCartes($indCarte) <ButtonRelease-1> "lacherCarte"
  .frmJeu.cnv bind $imgCartes($indCarte) <Motion> {deplacerCarteDraguee %X %Y}

  .frmJeu.cnv bind $imgCartes($indCarte) <Double-ButtonPress-1> "chercherDepotPourCarte $indCarte %X %Y"

}

proc chercherDepotPourCarte {indCarte x y} {
  global paquet
  global depots
  global PAQUET_POURC_Y
  global hautImages
  global indDerniereCarteDistribuee
  
  if {$paquet($indCarte,faceEnHaut)} {
    set trouveDepot false
    set indDepot 1
    while {!$trouveDepot && $indDepot <= 4} {
        set trouveDepot [essayeDeplaceSurDepot $indCarte $indDepot]
        incr indDepot
    }
    if {$trouveDepot && $indCarte == $indDerniereCarteDistribuee} {
      set indDerniereCarteDistribuee [cartePrecDistribuee $indCarte]
    }

#    for {set i 1} {$i <= 4} {incr i} {
#      # on essaye chaque dpot :
#      attraperCarte $indCarte $x $y
#      deplacerCarteDraguee [coordX $depots($i,posX)] [coordY [expr {($PAQUET_POURC_Y - $hautImages) / 2}]]
#      deplacerCarteDraguee [coordX $depots($i,posX)] [coordY [expr {($PAQUET_POURC_Y - $hautImages) / 2}]]
#      #msgBox ""
#      lacherCarte
#    }
  } else {
memoriserCoupAnnuler 1
    distribuer
  }
}

# spcifique ici
proc placerPaquet {xPourc yPourc} {
  global nbCartes
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global indDerniereCarteDistribuee
  global nbPassagesPaquet
  global mouvement

  set mouvement false
  
  set nbPassagesPaquet 0
  set PAQUET_POURC_X $xPourc
  set PAQUET_POURC_Y $yPourc
  tracerRectangleCarte "paquet" [coordX $PAQUET_POURC_X] [coordY $PAQUET_POURC_Y]
 .frmJeu.cnv bind paquet <ButtonPress-1> "rempilerPaquet"
  for {set i $nbCartes} {$i >= 1} {incr i -1} {
    placerCarte $i $xPourc $yPourc true
  }
  set indDerniereCarteDistribuee 0
}

proc rempilerPaquet {} {
  global indDerniereCarteDistribuee
  global paquet
  global depots
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global nbCartes
  global nbPassagesPaquet
  global nbCartesDistrib
  global mouvement
  global txt

  set continuer true
  # on regarde d'abord s'il ne resterait pas des cartes  distribuer...
  set i $indDerniereCarteDistribuee
  set resteCartes false
  while {$continuer} {
    if {$i <= $nbCartes} {
      if {! $paquet($i,distribuee)} {
        set continuer false
        set resteCartes true
      } else {
        incr i
      }
    } else {
      set continuer false
    }
  }
  if {! $resteCartes} {
    #msgBox "ok, il ne reste plus de carte !"
effacerCoupAnnuler
    incr nbPassagesPaquet
    set stop "no"
    if {!$mouvement} {
      set stop [msgBox "$txt(Familles,DDE_FIN_PARTIE)" "$txt(Familles,TITRE_DDE_FIN_PARTIE)" "yesno"]
    }
    if {$stop != "yes"} {
      set mouvement false 
      for {set indCarte $nbCartes} {$indCarte >= 1} {incr indCarte -1} {
        if {![carteSurDepot $indCarte]} {
          set paquet($indCarte,distribuee) false
          deplacerCarte $indCarte [coordX $PAQUET_POURC_X] [coordY $PAQUET_POURC_Y]
          .frmJeu.cnv raise Carte$indCarte
          retournerCarte $indCarte
        }
      }
      set indDerniereCarteDistribuee -1
    } else {
      verifierScore
      proposerRejouer
    }
  }
}

proc carteSurDepot {indCarte} {
  global depots
  global paquet

  set continuer true
  set trouve false
  set indDepot 1
  while {$continuer} {
        if {[lsearch $depots($indDepot,listeCartes) $indCarte] >= 0} {
          set continuer false
          set trouve true
        }
      incr indDepot
      if {$indDepot > 4} {
        set continuer false
#msgBox "la carte $paquet($indCarte) n'est pas sur un dpot"
      }
  }
  return $trouve
}

proc cartePrecDistribuee {indCarte} {
  set continuer true
  set i $indCarte
  while {$continuer} {
    if {[carteSurDepot $i]} {
      incr i -1
      if {$i <= 0} {
        set i -1
        set continuer false
      }
    } else {
      set continuer false
    }
  }
  return $i
}

proc initDepots {} {
  global hautImages
  global largImages
  global PAQUET_POURC_Y
  global depots

  unset depots
  set espaceEntreCol [expr {(100 - (4 * $largImages)) / 5}]

  for {set i 1} {$i <= 4} {incr i} {
    set depots($i,listeCartes) [list]
    set depots($i,posX) [expr {($espaceEntreCol * $i) + ($largImages * ($i - 1))}]
    tracerRectangleCarte "depot$i" [coordX $depots($i,posX)] [coordY [expr {($PAQUET_POURC_Y - $hautImages) / 2}]]
  }
}


# On distribue la carte indCarte sur le dpt indDepot
proc distribuerCarteSurDepot {indCarte indDepot} {
  global depots
  global paquet
  global PAQUET_POURC_Y
  global hautImages
  global joueurs
  global highScores
  global mouvement
  global txt
  
  set mouvement true
  gagner 1
  deplacerCarteSurDepot $indCarte $indDepot
  lappend depots($indDepot,listeCartes) $indCarte
#msgBox "$depots($indDepot,listeCartes)"
  set paquet($indCarte,distribuee) true
  if {[llength $depots($indDepot,listeCartes)] == 13} {
    gagner 12
  }
  if {[termine]} {
    verifierScore
    incrementerStats "$txt(STAT_NB_GAGNE)"
    proposerRejouer
  }
}

proc deplacerCarteSurDepot {indCarte indDepot} {
  global depots
  global PAQUET_POURC_Y
  global hautImages

#  set indColonne [expr {$nbColonnes - 4 + $indDepot}]
  deplacerCarte $indCarte [coordX $depots($indDepot,posX)] [coordY [expr {($PAQUET_POURC_Y - $hautImages) / 2}]]
  update idletasks
}

proc termine {} {
  global depots
  global nbCartes

  set nbCartesSurDepots 0
  for {set i 1} {$i <= 4} {incr i} {
    incr nbCartesSurDepots [llength $depots($i,listeCartes)]
  }
  if {$nbCartesSurDepots == $nbCartes} {
effacerCoupAnnuler
    return true
  } else {
    return false
  }
}

proc initScoresStats {} {
global jeuCourant
  global nbCartesDistrib
global titreScores
  global REP_HIGHSCORES
  global REP_STATS
  global txt

set titreScores "$txt($jeuCourant\,NOM) - $nbCartesDistrib $txt(TXT_CARTES)"
  chargerHighScores [file join $REP_HIGHSCORES "$jeuCourant\_$nbCartesDistrib\.txt"]
  chargerStats [file join $REP_STATS "$jeuCourant\.txt"]
}

proc majAfficheJeu {} {
  global depots
  global paquet
  global nbCartes
  global indDerniereCarteDistribuee
  global REP_HIGHSCORES
  global REP_STATS
  global nbCartesDistrib
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global hautImages
  global largImages

initScoresStats
  initAffichage
  set dernDistrib $indDerniereCarteDistribuee
#msgBox "$dernDistrib"

  set PAQUET_POURC_X [expr {50 - ($largImages / 2) - 5}]
  set PAQUET_POURC_Y 50
  tracerRectangleCarte "paquet" [coordX $PAQUET_POURC_X] [coordY $PAQUET_POURC_Y]
 .frmJeu.cnv bind paquet <ButtonPress-1> "rempilerPaquet"
  for {set i $nbCartes} {$i >= 1} {incr i -1} {
    placerCarte $i $PAQUET_POURC_X $PAQUET_POURC_Y [expr {! $paquet($i,faceEnHaut)}]
  }

#  initColonnes $nbColonnes
  for {set i 1} {$i <= $nbCartes} {incr i} {
  set paquet($i,distribuee) false
  }
  for {set i 1} {$i <= 4} {incr i} {
    tracerRectangleCarte "depot$i" [coordX $depots($i,posX)] [coordY [expr {($PAQUET_POURC_Y - $hautImages) / 2}]]
    foreach indCarte $depots($i,listeCartes) {
      set paquet($indCarte,distribuee) true
#set faceEnHaut($indCarte) $paquet($indCarte,faceEnHaut)
#    placerCarte $indCarte 110 110 true
      deplacerCarteSurDepot $indCarte $i
# set paquet($indCarte,faceEnHaut) $faceEnHaut($indCarte)  
      montrerCarte $indCarte true
    }
  }
  # maintenant, on distribue toutes les cartes jusqu' la derniere distribue :
  set indDerniereCarteDistribuee -1
  while {$dernDistrib > $indDerniereCarteDistribuee} {
    distribuer $dernDistrib
  }
 update

}

proc commencerPartie {} {
  global joueurs
  global SCORE_DE_DEPART
  global largImages
  global mouvement
global jeuCourant
global txt

  set mouvement false
  initPartie $jeuCourant
  initScoresStats
  initAffichage
  melangerPaquet
  placerPaquet [expr {50 - ($largImages / 2) - 5}] 50
  initDepots
#  distribuerCartes
  majAfficheScore
  afficherFrame frmJeu
  incrementerStats "$txt(STAT_NB_PARTIES)"
}

global lanceAuto
if {$lanceAuto} {
commencerPartie
}