#############################
#
#          SoloCartes
#
# Copyright 2008 Newmagic
#
#    This file is part of SoloCartes.
#
#    You can redistribute and/or modify
#    this software under the terms of the
#    Creative Commons  Attribution-NonCommercial-ShareAlike 3.0 Legal Code
#
#    See COPYING file(s) join to the distribution and/or
#    http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
#
#############################

global PARAM

set PARAM(rep) [info script]
set PARAM(rep) [file dirname $PARAM(rep)]
cd $PARAM(rep)

source "SoloCartes_initJeux.tcl"

global couleurFond
global couleurScore
afficherFrmAttente "" "" $couleurFond $couleurScore

array set imagesFaces [list]

global paquet

global nbColonnes
set nbColonnes 0

global colonnes
set colonnes(ind,posX) pourc
set colonnes(ind,listeCartes) [list]

global cartePrec
set cartePrec -1

global nbCartesDistrib
set nbCartesDistrib 5

global familleCartes
set familleCartes "P"

global LISTE_VARS_OPTIONS_JEU
set LISTE_VARS_OPTIONS_JEU [list nbCartesDistrib familleCartes]

global LISTE_VARS_SAUV_PARTIE
set LISTE_VARS_SAUV_PARTIE [list paquet colonnes nbColonnes nbCartes cartePrec nbCartesDistrib]

global jeuCourant
set jeuCourant "MemoryOrdre"
chargerOptionsJeu

global bloquePourTimer
set bloquePourTimer false
proc attraperCarte {indCarte x y} {
  global cartePrec
  global paquet
  global bloquePourTimer
  global jeuCourant
  global txt

  if {! $paquet($indCarte,faceEnHaut) && ! $bloquePourTimer} {
    set bloquePourTimer true
    retournerCarte $indCarte
    update idletasks
    set reglesOk false
    if {$cartePrec > 0} {
      if {[differenceCartes $cartePrec $indCarte] == -1} {
        set reglesOk true
      }
    } else {
      # C'est la premire qu'on retourne :
      if {[valeurCarte $indCarte] == 1} {
        set reglesOk true
      }
    }
    if {$reglesOk} {
        # OK !
        gagner 1
        set cartePrec $indCarte
        if {[termine]} {
          verifierScore
          incrementerStats "$txt(STAT_NB_GAGNE)"
          proposerRejouer
        }
    } else {
        # KO
        perdre 1
        pause 500
        if {$jeuCourant == "MemoryOrdre"} {
          retournerCarte $indCarte
        }
    }
    set bloquePourTimer false
  }
}


proc bindingsCarte {indCarte} {
  global imgCartes

  .frmJeu.cnv bind $imgCartes($indCarte) <ButtonPress-1> "attraperCarte $indCarte %X %Y"
  .frmJeu.cnv bind $imgCartes($indCarte) <ButtonRelease-1> "lacherCarte"
#  .frmJeu.cnv bind $imgCartes($indCarte) <Motion> {deplacerCarteDraguee %X %Y}

#.frmJeu.cnv bind $imgCartes($indCarte) <Double-ButtonPress-1> "retournerCarte $indCarte"

}

proc initColonnes {nb} {
  global nbColonnes
  global colonnes
  global hautImages
  global largImages
  global PAQUET_POURC_Y
  global depots

  unset colonnes
  set nbColonnes $nb
  set espaceEntreCol [expr {(100 - ($nbColonnes * $largImages)) / ($nbColonnes + 1)}]

  for {set i 1} {$i <= $nbColonnes} {incr i} {
    set colonnes($i,listeCartes) [list]
    set colonnes($i,posX) [expr {($espaceEntreCol * $i) + ($largImages * ($i - 1))}]
#    tracerRectangleCarte "col$i" [coordX $colonnes($i,posX)] [coordY [expr {$PAQUET_POURC_Y * 2 + $hautImages}]]
  }
}

proc distribuerCartes {} {
  global nbCartes
  global nbColonnes
  global indDerniereCarteDistribuee
  global typeScore
  global bloquePourTimer
  global jeuCourant
  global txt

  set bloquePourTimer true
  if {$jeuCourant == "MemoryOrdre"} {
    afficherFrame frmJeu
changeEtatActivationMenu disabled
    msgBox "$txt($jeuCourant\,MSG_DEBUT)" "$jeuCourant"
  }
  set indCarte 1
  while {$indCarte <= $nbCartes} {
    for {set i 1} {$i <= $nbColonnes} {incr i} {
      if {$indCarte <= $nbCartes} {
        placerCarte $indCarte 110 110 true
        distribuerCarteSurColonne $indCarte $i ;# true
        retournerCarte $indCarte
        incr indCarte
      }
    }
  }
  pause 4000
  if {$bloquePourTimer && $jeuCourant == "MemoryOrdre"} {
    for {set i 1} {$i <= $nbCartes} {incr i} {
        retournerCarte $i
    }
    set bloquePourTimer false
  }
changeEtatActivationMenu normal
}

# Active ou dsactive le menu, selon l'tat indiqu ("normal" ou "disabled")
proc changeEtatActivationMenu {nouvEtat} {
  .menu10 entryconfigure 1 -state $nouvEtat
  .menu10 entryconfigure 2 -state $nouvEtat
  .menu10 entryconfigure 3 -state $nouvEtat
}

proc deplacerCarteSurColonne {indCarte indColonne rang {avecAnimation false}} {
  global colonnes
  global paquet
  global PAQUET_POURC_Y
  global hautImages

  global nbCartes
  global nbColonnes

  set nbCartesParCol [expr {int($nbCartes / $nbColonnes)}]
  if {[expr {$nbCartes % $nbColonnes}] > 0} {
    incr nbCartesParCol
  }
  set yEntreCartes [expr {(80 - ($nbCartesParCol * $hautImages)) / ($nbCartesParCol + 1)}]

  set yPourc [expr {$yEntreCartes + ($hautImages + $yEntreCartes) * $rang}]
  deplacerCarte $indCarte [coordX $colonnes($indColonne,posX)] [coordY $yPourc] $avecAnimation
}

proc termine {} {
  global paquet
  global nbCartes

  set resteCartesFacesEnBas false
  for {set i 1} {$i <= $nbCartes && !$resteCartesFacesEnBas} {incr i} {
    if {! $paquet($i,faceEnHaut)} {
      set resteCartesFacesEnBas true
    }
  }
  if {$resteCartesFacesEnBas} {
    return false
  } else {
    return true
  }
}


proc initScoresStats {} {
global jeuCourant
  global nbCartes
  global nbCartesDistrib
global titreScores
  global REP_HIGHSCORES
  global REP_STATS
  global txt

set titreScores "$txt($jeuCourant\,NOM) - $nbCartes $txt(TXT_CARTES)"
  chargerHighScores [file join $REP_HIGHSCORES "$jeuCourant\_$nbCartesDistrib\.txt"]
  chargerStats [file join $REP_STATS "$jeuCourant\.txt"]
}

proc majAfficheJeu {} {
  global colonnes
  global nbColonnes
  global paquet
  global nbCartes
  global bloquePourTimer
  global jeuCourant
  global nbCartesDistrib

  set bloquePourTimer true

#  initPartie "Memory ordre"
#  melangerPaquet "CartesFigures.txt"
initScoresStats
  initAffichage
#  initColonnes 5
#  incrementerStats "Nb parties"
#  distribuerCartes

changeEtatActivationMenu disabled
  for {set i 1} {$i <= $nbColonnes} {incr i} {
    set rang 0
    foreach indCarte $colonnes($i,listeCartes) {
      set faceEnHaut($indCarte) $paquet($indCarte,faceEnHaut)
      placerCarte $indCarte 110 110 true
      deplacerCarteSurColonne $indCarte $i $rang
      montrerCarte $indCarte true
      incr rang
    }
  }
afficherFrame frmJeu
  pause 4000
  if {$bloquePourTimer && $jeuCourant == "MemoryOrdre"} {
    for {set indCarte 1} {$indCarte <= $nbCartes} {incr indCarte} {
      set paquet($indCarte,faceEnHaut) $faceEnHaut($indCarte)
      montrerCarte $indCarte $paquet($indCarte,faceEnHaut)
    }
    update idletasks
    set bloquePourTimer false
  }
changeEtatActivationMenu normal
}


proc commencerPartie {} {
  global joueurs
  global SCORE_DE_DEPART
  global nbCartesDistrib
  global typeScore
  global nbCartesDistrib
global jeuCourant
global nbCartes
global titreScores
global dosCartes
global paquet
global nbCartesDistrib
global familleCartes
global cartePrec
global txt

  initPartie $jeuCourant
set cartePrec -1
  set nbCols $nbCartesDistrib
  if {$nbCartesDistrib > 4} {
    set nbCols 5
  }
#  melangerPaquet
set listeFaces [list]
  for {set i 1} {$i <= $nbCartesDistrib} {incr i} {
    set valeur $i
    if {$i == 1} {set valeur "A"}
    if {$i == 11} {set valeur "V"}
    if {$i == 12} {set valeur "D"}
    if {$i == 13} {set valeur "R"}
lappend listeFaces "$valeur$familleCartes"
  }
melangerPaquetListeCartes $listeFaces
initScoresStats
  initAffichage
  majAfficheScore
  initColonnes $nbCols
  incrementerStats "$txt(STAT_NB_PARTIES)"
  distribuerCartes
}

proc modifierFamille {nouvFamille} {
  global familleCartes
  global nbCartes
  global paquet
  
  set familleCartes $nouvFamille
  for {set i 1} {$i <= $nbCartes} {incr i} {
    set paquet($i) "[string range $paquet($i) 0 end-1]$familleCartes"
    if {$paquet($i,faceEnHaut)} {
      montrerCarte $i
    }
  }
}

global lanceAuto
if {$lanceAuto} {
commencerPartie
}
