#############################
#
#          SoloCartes
#
# Copyright 2008 Newmagic
#
#    This file is part of SoloCartes.
#
#    You can redistribute and/or modify
#    this software under the terms of the
#    Creative Commons  Attribution-NonCommercial-ShareAlike 3.0 Legal Code
#
#    See COPYING file(s) join to the distribution and/or
#    http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
#
#############################

global PARAM

set PARAM(rep) [info script]
set PARAM(rep) [file dirname $PARAM(rep)]
cd $PARAM(rep)

source "SoloCartes_initJeux.tcl"

global typeScore
set typeScore "classique"

global nbCartesDistrib
set nbCartesDistrib 1

global facesEnHaut
set facesEnHaut false

global LISTE_VARS_OPTIONS_JEU
set LISTE_VARS_OPTIONS_JEU [list typeScore nbCartesDistrib facesEnHaut]

global LISTE_VARS_SAUV_PARTIE
set LISTE_VARS_SAUV_PARTIE [list paquet depots colonnes nbColonnes nbPassagesPaquet indDerniereCarteDistribuee nbCartes typeScore nbCartesDistrib facesEnHaut]

global jeuCourant
set jeuCourant Solitaire
chargerOptionsJeu

array set imagesFaces [list]


proc depotSousXY {x y} {
  global PAQUET_POURC_Y
  global hautImages

  set pourcY [pourcCoordY $y]
  if {$pourcY < [expr {$PAQUET_POURC_Y + $hautImages}]} {
    set indCol [colSousPourcXY [pourcCoordX $x] [expr {[pourcCoordY $y] + $hautImages + 2 * $PAQUET_POURC_Y}]]
    set indDepot [expr {$indCol - 3}]
    if {$indDepot <= 0} {
      set indDepot -1
    }
    return $indDepot
  } else {
    return -1
  }
}

proc colSousXY {x y} {
  return [colSousPourcXY [pourcCoordX $x] [pourcCoordY $y]]
}

proc colSousPourcXY {pourcX pourcY} {
  global nbColonnes
  global colonnes
  global largImages
  global PAQUET_POURC_Y
  global hautImages

#  if {$pourcY >= [expr {$PAQUET_POURC_Y * 2 + $hautImages}]}
  if {$pourcY >= [expr {$PAQUET_POURC_Y * 2}]} {
    set continuer true
    set i 0
    set minCarte $pourcX
#    set maxCarte [expr {$pourcX + [pourcCoordX $largImages]}]
    set maxCarte [expr {$pourcX + $largImages}]
    set milieuCarte [expr {$minCarte + (($maxCarte - $minCarte) / 2)}]
    set colDroite -1
    set colGauche -1
    set distGauche -1
    set distDroite -1

#msgBox "$pourcX [pourcCoordX $largImages] => $milieuCarte"
    while {$continuer} {
      incr i
      if {$i <= $nbColonnes} {
        set minCol $colonnes($i,posX)
        if {$minCol > $maxCarte} {
          # ca sert  rien d'aller + loin
          set continuer false
        }
        if {$continuer} {
#          set maxCol [expr {$minCol + [pourcCoordX $largImages]}]
          set maxCol [expr {$minCol + $largImages}]
          if {$minCarte >= $minCol && $minCarte <= $maxCol} {
            set colGauche $i
#            set distGauche [expr {$maxCol - $minCarte}]
            set distGauche [expr {$maxCarte - $minCol}]
          }
          if {$maxCarte >= $minCol && $maxCarte <= $maxCol} {
            set colDroite $i
#            set distDroite [expr {$maxCarte - $minCol}]
            set distDroite [expr {$maxCol - $minCarte}]
          }
        }
      } else {
        set continuer false
      }
    }
    set indCol $colGauche
    if {$colGauche > 0 && $colDroite > 0} {
      # on regarde le plus prs :
      if {$distGauche > $distDroite} {
        set indCol $colDroite
      }
    }
    if {$indCol == -1} {
      set indCol $colDroite
    }
    return $indCol
  } else {
    return -1
  }
}

global paquet

global nbColonnes
set nbColonnes 0

global colonnes
set colonnes(ind,posX) pourc
set colonnes(ind,listeCartes) [list]

global depots
set depots(ind,listeCartes) [list]

global nbPassagesPaquet
set nbPassagesPaquet 0

proc attraperCarte {indCarte x y} {
  global indCarteDragguee
  global indCarteDraggueeTmp
  global diffX
  global diffY
  global imgCartes
  global paquet
  global x_initDrag
  global y_initDrag
  global colonnes
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global largImages
  global indDerniereCarteDistribuee
  global nbCartes
  global typeScore
  global nbCartesDistrib
  global nbPassagesPaquet


  set liste [.frmJeu.cnv coords $imgCartes($indCarte)]
  set x_carte [lindex $liste 0]
  set y_carte [lindex $liste 1]
  if {$paquet($indCarte,distribuee)} {
    if {$paquet($indCarte,faceEnHaut)} {
      if {[carteSurColOuDepot $indCarte] || $indCarte == $indDerniereCarteDistribuee} {
        set indCarteDraggueeTmp $indCarte
        .frmJeu.cnv raise Carte$indCarteDraggueeTmp
        set x_initDrag $x_carte
        set y_initDrag $y_carte
        set diffX [expr {$x - $x_initDrag}]
        set diffY [expr {$y - $y_initDrag}]
      }
    } else {
      # elle est  l'envers => on retourne face en haut
      # la dernire de la colonne :
      set indCol [colSousXY $x_carte $y_carte]
      if {$indCol > 0} {
        set derniere [lindex $colonnes($indCol,listeCartes) end]
        if {! $paquet($derniere,faceEnHaut)} {
          retournerCarte $derniere
          if {$typeScore != "vegas"} {
            gagner 5
          }
  effacerCoupAnnuler
        }
      }
    }
  } else {
    if {[pourcCoordX $x_carte] == $PAQUET_POURC_X && [pourcCoordY $y_carte] == $PAQUET_POURC_Y} {
      # clic sur paquet
set nbPointsAnnule 0
global typeScore
if {$typeScore != "vegas"} {
          set nbPointsAnnule 2
}
memoriserCoupAnnuler $nbPointsAnnule
      distribuer
#msgBox "$indCarte"
    }
  }
}

proc distribuer {{jusqua ""}} {
  global indDerniereCarteDistribuee
  global paquet
  global nbCartesDistrib
  global nbCartes
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global largImages
  global imgCartes
  
  if {$jusqua == ""} {
    set jusqua $nbCartes ;# Pas de limite (sauf le nombre de cartes du paquet)
  }
  if {$indDerniereCarteDistribuee <= 0} {
    # On n'a pas encore distribue de carte
    set indDerniereCarteDistribuee 1 ;# on passe direct  la 1
  } else {
#    set prec $indDerniereCarteDistribuee
    #incr prec -1
    set prec [cartePrecDistribuee $indDerniereCarteDistribuee]
    set i 1
    while {$i < $nbCartesDistrib && $prec > 0} {
      # On "tasse" les cartes prcdemment distribues
      .frmJeu.cnv coords $imgCartes($prec) [list [coordX [expr {2 * $PAQUET_POURC_X + $largImages}]] [coordY $PAQUET_POURC_Y]]
      incr i
      incr prec -1
      set prec [cartePrecDistribuee $prec]
    }
  }
  for {set i 0} {$i < $nbCartesDistrib} {incr i} {
    set continuer true
    while {$continuer} {
#msgBox "$jusqua $indDerniereCarteDistribuee"
      if {$indDerniereCarteDistribuee <= $jusqua} {
        if {! $paquet($indDerniereCarteDistribuee,distribuee)} {
          set indCarte $indDerniereCarteDistribuee
          set paquet($indCarte,faceEnHaut) false
          deplacerCarte $indCarte [coordX [expr {2 * $PAQUET_POURC_X + $largImages + 3 * $i}]] [coordY $PAQUET_POURC_Y]
          retournerCarte $indCarte
          set paquet($indCarte,distribuee) true
          set continuer false
        } else {
          incr indDerniereCarteDistribuee
        }
      } else {
        set indDerniereCarteDistribuee $jusqua
        set continuer false
      }
    }
  }
}


global lstCartesSousDraguee
set lstCartesSousDraguee [list]

proc lacherCarte {} {
  global indCarteDragguee
  global indCarteDraggueeTmp
  global imgCartes
  global diffX
  global diffY
  global x_initDrag
  global y_initDrag
  global colonnes
  global paquet
  global nbColonnes
  global depots
  global indDerniereCarteDistribuee
  global typeScore

  set diffX 0
  set diffY 0
  set deplaceOk false
  if {$indCarteDraggueeTmp > 0} {
    set indCarteDragguee $indCarteDraggueeTmp
    set indCarte $indCarteDragguee
    set liste [.frmJeu.cnv coords $imgCartes($indCarte)]
    set x [lindex $liste 0]
    set y [lindex $liste 1]
    set indCol [colSousXY $x $y]

    if {$indCol > 0} {
      # rgles
      set reglesOk false
      set nbCartesSurCol [llength $colonnes($indCol,listeCartes)]
      if {$nbCartesSurCol > 0} {
        set derniereCarteCol [lindex $colonnes($indCol,listeCartes) [expr {$nbCartesSurCol - 1}]]
        if {[differenceCartes $derniereCarteCol $indCarte] == 1 && [couleurRN $derniereCarteCol] != [couleurRN $indCarte]} {
          # 1 et couleur change => ok
          set reglesOk true
        }
      } else {
        if {[string range $paquet($indCarte) 0 0] == "R"} {
          # roi => ok
          set reglesOk true
        }
      }
      if {$reglesOk} {
set nbPointsAnnule 0
if {$typeScore != "vegas"} {
          set nbPointsAnnule 2
}
memoriserCoupAnnuler $nbPointsAnnule
        set indAncienneCol [colSousXY $x_initDrag $y_initDrag]
        if {$indAncienneCol != $indCol} {
          if {$indAncienneCol > 0} {
            set indDansAncienneCol [lsearch $colonnes($indAncienneCol,listeCartes) $indCarte]
            set long [llength $colonnes($indAncienneCol,listeCartes)]
            for {set i $indDansAncienneCol} {$i < $long} {incr i} {
              distribuerCarteSurColonne [lindex $colonnes($indAncienneCol,listeCartes) $i] $indCol
            }
            for {set i $indDansAncienneCol} {$i < $long} {incr i} {
              enleverDerniereCarteCol $indAncienneCol
            }
          } else {
            # Elle vient d'ailleurs (paquet ou dpt)
            # On la place sur la colonne :
            set gain 0
            set indDepot [depotSousXY $x_initDrag $y_initDrag]
            if {$indDepot > 0} {
              enleverDerniereCarteDepot $indDepot
            } else {
              if {$typeScore != "vegas"} {
                set gain 5
              }
            }
            distribuerCarteSurColonne $indCarte $indCol $gain
          }
          set deplaceOk true
        } else {
          set reglesOk false
        }
      }
    }
    if {!$deplaceOk} {
      # on tente le dpt
      set indDepot [depotSousXY $x $y]
      if {$indDepot > 0} {
        set deplaceOk [essayeDeplaceSurDepot $indCarte $indDepot $x_initDrag $y_initDrag]
      }
    }
    if {!$deplaceOk} {
      # on la replace o elle tait
      deplacerCarteDraguee $x_initDrag $y_initDrag
    } else {
      if {$indCarte == $indDerniereCarteDistribuee} {
        set indDerniereCarteDistribuee [cartePrecDistribuee $indCarte]
      }
    }
  }
  set indCarteDragguee -1
  set indCarteDraggueeTmp -1
  global lstCartesSousDraguee
  set lstCartesSousDraguee [list]
  return $deplaceOk
}

proc essayeDeplaceSurDepot {indCarte indDepot {x_initDrag ""} {y_initDrag ""}} {
  global depots
  global paquet
  global colonnes
  global typeScore
  global imgCartes
  
  if {$x_initDrag == "" || $y_initDrag == ""} {
    # On rcupre les coordonnes de la carte :
    set liste [.frmJeu.cnv coords $imgCartes($indCarte)]
    set x_initDrag [lindex $liste 0]
    set y_initDrag [lindex $liste 1]
    
  }
        set reglesOk false
        set deplaceOk false
        set nbCartesSurDepot [llength $depots($indDepot,listeCartes)]
        if {$nbCartesSurDepot > 0} {
          set derniereCarteDepot [lindex $depots($indDepot,listeCartes) end]
          if {[differenceCartes $derniereCarteDepot $indCarte] == -1 && [famillePCKT $derniereCarteDepot] == [famillePCKT $indCarte]} {
            # -1 et mme famille => ok
            set reglesOk true
          }
        } else {
#msgBox "$paquet($indCarte)"
          if {[string range $paquet($indCarte) 0 0] == "A"} {
            # as => ok
            set reglesOk true
          }
        }
        if {$reglesOk} {
          set indAncienneCol [colSousXY $x_initDrag $y_initDrag]
#msgBox "indAncienneCol : $indAncienneCol ($x_initDrag)"
          if {$indAncienneCol > 0} {
            set indDansAncienneCol [lsearch $colonnes($indAncienneCol,listeCartes) $indCarte]
            if {$indDansAncienneCol == [expr {[llength $colonnes($indAncienneCol,listeCartes)] - 1}]} {
set nbPointsAnnule 0
if {$typeScore != "vegas"} {
          set nbPointsAnnule 2
}
memoriserCoupAnnuler $nbPointsAnnule
              enleverDerniereCarteCol $indAncienneCol
              distribuerCarteSurDepot $indCarte $indDepot
              set deplaceOk true
            } else {
              # ce n'est pas la dernire de sa colonne => ko
              set deplaceOk false
            }
          } else {
            # Elle vient d'ailleurs (paquet ou dpt)
            # On la place sur le dpt :
            set indAncienDepot [depotSousXY $x_initDrag $y_initDrag]
set nbPointsAnnule 0
if {$typeScore != "vegas"} {
          set nbPointsAnnule 2
}
memoriserCoupAnnuler $nbPointsAnnule
            if {$indAncienDepot > 0} {
              enleverDerniereCarteDepot $indAncienDepot
            }
#msgBox "on la place sur depot $indDepot"
            distribuerCarteSurDepot $indCarte $indDepot
            set deplaceOk true
          }
        }
        return $deplaceOk
}

proc deplacerCarteDraguee {x y} {
  global indCarteDragguee
  global indCarteDraggueeTmp
  global x_initDrag
  global y_initDrag
  global colonnes
  global paquet
  global lstCartesSousDraguee

  if {$indCarteDragguee > 0} {
    set ok true
    if {[llength $lstCartesSousDraguee] == 0} {
      # on regarde si toutes les cartes dessous vrifient bien les rgles :
      set indCol [colSousXY $x_initDrag $y_initDrag]
      if {$indCol > 0} {
        set indDansCol [lsearch $colonnes($indCol,listeCartes) $indCarteDragguee]
        incr indDansCol
        if {$indDansCol > 0} {
          set coulAttendue [couleurRN $indCarteDragguee]
          set i $indDansCol
          set continuer true
          if {$i >= [llength $colonnes($indCol,listeCartes)]} {
            set continuer false
          }
          while {$continuer} {
            if {$coulAttendue == "R"} {
              set coulAttendue "N"
            } else {
              set coulAttendue "R"
            }
            set indCarteSuiv [lindex $colonnes($indCol,listeCartes) $i]
#msgBox "$i $indCarteSuiv"
#msgBox "[expr {$i-$indDansCol+1}]"
            if {[differenceCartes $indCarteDragguee $indCarteSuiv] != [expr {$i-$indDansCol+1}]} {
              set ok false
            }
            if {"[couleurRN $indCarteSuiv]" != "$coulAttendue"} {
              # ca passe pas...
              set ok false
            }
            if {! $ok} {
              set continuer false
            } else {
              incr i
              if {$i >= [llength $colonnes($indCol,listeCartes)]} {
                set continuer false
              }
            }
          }
          if {$ok} {
            set lstCartesSousDraguee [lrange $colonnes($indCol,listeCartes) $indDansCol end]
          } else {
            for {set i $indDansCol} {$i < [llength $colonnes($indCol,listeCartes)]} {incr i} {
              .frmJeu.cnv raise "Carte[lindex $colonnes($indCol,listeCartes) $i]"
            }
          }
        }
      }
    }
    if {$ok} {
      set yDessus $y
      deplacerCarte $indCarteDragguee $x $y
      # on prend toutes celles qui sont dessous ET QUI REPONDENT AUX REGLES :
      foreach i $lstCartesSousDraguee {
        set diff [coordY [expr 3]]
        set yDessus [expr {$diff + $yDessus}]
        deplacerCarte $i $x $yDessus
      }
    }
  } else {
    set diffX [expr {$x - $x_initDrag}]
    if {$diffX < 0} {set diffX [expr {0 - $diffX}]}
    set diffY [expr {$y - $y_initDrag}]
    if {$diffY < 0} {set diffY [expr {0 - $diffY}]}
    set diffActive 50
    #msgBox "$diffX $diffY"
    if {$diffX > $diffActive || $diffY > $diffActive} {
      set indCarteDragguee $indCarteDraggueeTmp
    }
  }
}


proc bindingsCarte {indCarte} {
  global imgCartes

  .frmJeu.cnv bind $imgCartes($indCarte) <ButtonPress-1> "attraperCarte $indCarte %X %Y"
  .frmJeu.cnv bind $imgCartes($indCarte) <ButtonRelease-1> "lacherCarte"
  .frmJeu.cnv bind $imgCartes($indCarte) <Motion> {deplacerCarteDraguee %X %Y}

  .frmJeu.cnv bind $imgCartes($indCarte) <Double-ButtonPress-1> "chercherDepotPourCarte $indCarte %X %Y"

}

proc chercherDepotPourCarte {indCarte x y} {
  global paquet
  global depots
  global colonnes
  global nbColonnes
  global PAQUET_POURC_Y
  global indDerniereCarteDistribuee

  if {$paquet($indCarte,faceEnHaut)} {
    set trouveDepot false
    set indDepot 1
    while {!$trouveDepot && $indDepot <= 4} {
        set trouveDepot [essayeDeplaceSurDepot $indCarte $indDepot]
        incr indDepot
    }
    if {$trouveDepot && $indCarte == $indDerniereCarteDistribuee} {
      set indDerniereCarteDistribuee [cartePrecDistribuee $indCarte]
    }

#    for {set i 1} {$i <= 4} {incr i} {
#      # on essaye chaque dpot :
#      attraperCarte $indCarte $x $y
#      set indCol [expr {$i + $nbColonnes - 4}]
#      deplacerCarteDraguee [coordX $colonnes($indCol,posX)] [coordY $PAQUET_POURC_Y]
#      deplacerCarteDraguee [coordX $colonnes($indCol,posX)] [coordY $PAQUET_POURC_Y]
#      #msgBox ""
#      if {[lacherCarte]} {
#        set i 5 ;# On a trouv => on s'arrte
#      }
#    }
  } else {
    if {! $paquet($indCarte,distribuee)} {
      set nbPointsAnnule 0
global typeScore
      if {$typeScore != "vegas"} {
          set nbPointsAnnule 2
      }
      memoriserCoupAnnuler $nbPointsAnnule
      distribuer
    }
  }
}

proc rempilerPaquet {} {
  global indDerniereCarteDistribuee
  global paquet
  global colonnes
  global nbColonnes
  global depots
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global nbCartes
  global nbPassagesPaquet
  global typeScore
  global nbCartesDistrib

  set continuer true
  # on regarde d'abord s'il ne resterait pas des cartes  distribuer...
  set i $indDerniereCarteDistribuee
  set resteCartes false
  set paquetContientCartes false
  while {$continuer} {
    if {$i <= $nbCartes && $i >= 0} {
      set paquetContientCartes true
      if {! $paquet($i,distribuee)} {
        set continuer false
        set resteCartes true
      } else {
        incr i
      }
    } else {
      set continuer false
    }
  }
  if {$paquetContientCartes && ! $resteCartes} {
    #msgBox "ok, il ne reste plus de carte !"
    # Voyons maintenant si on le peut :
    incr nbPassagesPaquet
    set reglesOkDistribuer true
    if {$typeScore == "vegas"} {
      if {$nbPassagesPaquet >= $nbCartesDistrib} {
        set reglesOkDistribuer false
      }
    } else {
      if {$nbCartesDistrib == 3 && $nbPassagesPaquet >= $nbCartesDistrib} {
        perdre 20
      }
      if {$nbCartesDistrib == 2 && $nbPassagesPaquet >= $nbCartesDistrib} {
        perdre 50
      }
      if {$nbCartesDistrib == 1 && $nbPassagesPaquet >= $nbCartesDistrib} {
        perdre 100
      }
    }
    if {$reglesOkDistribuer} {
effacerCoupAnnuler
      for {set indCarte $nbCartes} {$indCarte >= 1} {incr indCarte -1} {
        if {![carteSurColOuDepot $indCarte]} {
          set paquet($indCarte,distribuee) false
          deplacerCarte $indCarte [coordX $PAQUET_POURC_X] [coordY $PAQUET_POURC_Y]
          .frmJeu.cnv raise Carte$indCarte
          retournerCarte $indCarte
        }
      }
      set indDerniereCarteDistribuee -1
    }
  }
}

proc carteSurColOuDepot {indCarte} {
  global colonnes
  global nbColonnes
  global depots

  set continuer true
  set trouve false
  set indCol 1
  while {$continuer} {
    if {[lsearch $colonnes($indCol,listeCartes) $indCarte] >= 0} {
      set continuer false
      set trouve true
    }
    if {$continuer} {
      set indDepot [expr {$indCol - 3}]
      if {$indDepot > 0} {
        if {[lsearch $depots($indDepot,listeCartes) $indCarte] >= 0} {
          set continuer false
          set trouve true
        }
      }
      incr indCol
      if {$indCol > $nbColonnes} {
        set continuer false
      }
    }
  }
  return $trouve
}

proc cartePrecDistribuee {indCarte} {
  set continuer true
  set i $indCarte
  while {$continuer} {
    if {[carteSurColOuDepot $i]} {
      incr i -1
      if {$i <= 0} {
        set i -1
        set continuer false
      }
    } else {
      set continuer false
    }
  }
  return $i
}

proc initColonnes {nb} {
  global nbColonnes
  global colonnes
  global hautImages
  global largImages
  global PAQUET_POURC_Y
  global depots

  unset colonnes
  set nbColonnes $nb
  set espaceEntreCol [expr {(100 - ($nbColonnes * $largImages)) / ($nbColonnes + 1)}]

  for {set i 1} {$i <= $nbColonnes} {incr i} {
    set colonnes($i,listeCartes) [list]
    set colonnes($i,posX) [expr {($espaceEntreCol * $i) + ($largImages * ($i - 1))}]
    tracerRectangleCarte "col$i" [coordX $colonnes($i,posX)] [coordY [expr {$PAQUET_POURC_Y * 2 + $hautImages}]]
  }
  # on en profite pour calculer les "dpts" :
  set indDepot 1
  for {set i [expr {$nbColonnes - 3}]} {$i <= $nbColonnes} {incr i} {
    tracerRectangleCarte "depot$indDepot" [coordX $colonnes($i,posX)] [coordY $PAQUET_POURC_Y]
    set depots($indDepot,listeCartes) [list]
    incr indDepot
  }
}

proc distribuerCartes {} {
  global nbColonnes
  global indDerniereCarteDistribuee
  global typeScore
  global facesEnHaut
  
  set lstCartesARetourner [list]
  set indCarte 1
  set indCol 1
  set continuer true
  while {$indCol <= $nbColonnes} {
    for {set i $indCol} {$i <= $nbColonnes} {incr i} {
      distribuerCarteSurColonne $indCarte $i ;# true
      if {$facesEnHaut} {
        retournerCarte $indCarte
      } else {
        if {$i == $indCol} {
          lappend lstCartesARetourner $indCarte
#        retournerCarte $indCarte
        }
      }
      incr indCarte
    }
    incr indCol
  }
  set indDerniereCarteDistribuee $indCarte
  incr indDerniereCarteDistribuee -1
  foreach indCarte $lstCartesARetourner {
    retournerCarte $indCarte
  }
  if {$typeScore == "vegas"} {
    perdre 52
  }
}

proc enleverDerniereCarteDepot {indDepot} {
  global depots
  global typeScore
  set depots($indDepot,listeCartes) [lreplace $depots($indDepot,listeCartes) end end]
  if {$typeScore == "vegas"} {
    perdre 5
  } else {
    perdre 10
  }
}

proc deplacerCarteSurColonne {indCarte indColonne rang {avecAnimation false}} {
  global colonnes
  global paquet
  global PAQUET_POURC_Y
  global hautImages

  set yPourc [expr {$PAQUET_POURC_Y * 2 + $hautImages + 3 * $rang}]
  deplacerCarte $indCarte [coordX $colonnes($indColonne,posX)] [coordY $yPourc] $avecAnimation
}

# On distribue la carte indCarte sur le dpt indDepot
proc distribuerCarteSurDepot {indCarte indDepot} {
  global colonnes
  global nbColonnes
  global depots
  global paquet
  global PAQUET_POURC_Y
  global hautImages
  global typeScore
  global joueurs
  global highScores
  global txt


  deplacerCarteSurDepot $indCarte $indDepot
  lappend depots($indDepot,listeCartes) $indCarte
  set paquet($indCarte,distribuee) true

  if {$typeScore == "vegas"} {
    gagner 5
  } else {
    gagner 10
  }
  if {[termine]} {
    verifierScore
    incrementerStats "$txt(STAT_NB_GAGNE)"
    proposerRejouer
  }
}

proc deplacerCarteSurDepot {indCarte indDepot} {
  global colonnes
  global nbColonnes
  global PAQUET_POURC_Y

  set indColonne [expr {$nbColonnes - 4 + $indDepot}]
  deplacerCarte $indCarte [coordX $colonnes($indColonne,posX)] [coordY $PAQUET_POURC_Y]
  update ;#idletasks
}

proc termine {} {
  global depots
  global nbCartes
global indCarteDragguee
global indCarteDraggueeTmp

  set nbCartesSurDepots 0
  for {set i 1} {$i <= 4} {incr i} {
    incr nbCartesSurDepots [llength $depots($i,listeCartes)]
  }
  if {$nbCartesSurDepots == $nbCartes} {
  set indCarteDragguee -1
  set indCarteDraggueeTmp -1
  global lstCartesSousDraguee
  set lstCartesSousDraguee [list]
effacerCoupAnnuler
    return true
  } else {
    return false
  }
}


proc initScoresStats {} {
global jeuCourant
  global nbCartes
  global nbCartesDistrib
  global typeScore
global titreScores
  global REP_HIGHSCORES
  global REP_STATS
  global facesEnHaut
  global txt

set titreScores "$txt($jeuCourant\,NOM) - $nbCartesDistrib $txt(TXT_CARTES) - $txt($jeuCourant\,SCORE_$typeScore)"
set nomFicScores "$jeuCourant\_$typeScore\_$nbCartesDistrib"
  if {$facesEnHaut} {
    append titreScores "\n$txt(TXT_CARTES_VISIBLES)"
    append nomFicScores "_visibles"
  }
  chargerHighScores [file join $REP_HIGHSCORES "$nomFicScores\.txt"]
  chargerStats [file join $REP_STATS "$jeuCourant\.txt"]
}

proc majAfficheJeu {} {
  global colonnes
  global nbColonnes
  global depots
  global paquet
  global nbCartes
  global indDerniereCarteDistribuee
  global nbCartesDistrib
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global hautImages
  global nbPassagesPaquet

  initScoresStats
  initAffichage
  set dernDistrib $indDerniereCarteDistribuee
#msgBox "$dernDistrib"

  set PAQUET_POURC_X 5
  set PAQUET_POURC_Y 5
  tracerRectangleCarte "paquet" [coordX $PAQUET_POURC_X] [coordY $PAQUET_POURC_Y]
 .frmJeu.cnv bind paquet <ButtonPress-1> "rempilerPaquet"
  for {set i $nbCartes} {$i >= 1} {incr i -1} {
    placerCarte $i $PAQUET_POURC_X $PAQUET_POURC_Y [expr {! $paquet($i,faceEnHaut)}]
  }

  #  initColonnes $nbColonnes
  for {set i 1} {$i <= $nbCartes} {incr i} {
    set paquet($i,distribuee) false
  }
  set indDerniereCarteDistribuee 0
  for {set i 1} {$i <= $nbColonnes} {incr i} {
    tracerRectangleCarte "col$i" [coordX $colonnes($i,posX)] [coordY [expr {$PAQUET_POURC_Y * 2 + $hautImages}]]
    set rang 0
    #msgBox "$i : $colonnes($i,listeCartes)"
    foreach indCarte $colonnes($i,listeCartes) {
      set paquet($indCarte,distribuee) true
      set faceEnHaut($indCarte) $paquet($indCarte,faceEnHaut) 
      #    placerCarte $indCarte 110 110 true
      deplacerCarteSurColonne $indCarte $i $rang
      set paquet($indCarte,faceEnHaut) $faceEnHaut($indCarte)
      montrerCarte $indCarte $paquet($indCarte,faceEnHaut)
      incr rang
      incr indDerniereCarteDistribuee
    }
  }
  for {set i 1} {$i <= 4} {incr i} {
    set indCol [expr {$i + $nbColonnes - 4}]
    tracerRectangleCarte "depot$i" [coordX $colonnes($indCol,posX)] [coordY $PAQUET_POURC_Y]
    foreach indCarte $depots($i,listeCartes) {
      set paquet($indCarte,distribuee) true
      #set faceEnHaut($indCarte) $paquet($indCarte,faceEnHaut) 
      #    placerCarte $indCarte 110 110 true
      deplacerCarteSurDepot $indCarte $i
      # set paquet($indCarte,faceEnHaut) $faceEnHaut($indCarte)  
      montrerCarte $indCarte true
      incr indDerniereCarteDistribuee
    }
  }
  # maintenant, on distribue toutes les cartes jusqu' la derniere distribue :
#  set indDerniereCarteDistribuee -1
  set indDerniereCarteDistribuee -1
  while {$dernDistrib > $indDerniereCarteDistribuee} {
    distribuer $dernDistrib
#msgBox "$indDerniereCarteDistribuee"
  }
  update
}

proc commencerPartie {} {
  global joueurs
  global SCORE_DE_DEPART
  global nbCartesDistrib
global jeuCourant
  global titreScores
  global txt
  
  initPartie $jeuCourant
  initScoresStats
  initAffichage
  melangerPaquet
  placerPaquet 5 5
  initColonnes 7
  distribuerCartes
  majAfficheScore
  afficherFrame frmJeu
  incrementerStats "$txt(STAT_NB_PARTIES)"
}

global lanceAuto
if {$lanceAuto} {
commencerPartie
}