#############################
#
#          SoloCartes
#
# Copyright 2008 Newmagic
#
#    This file is part of SoloCartes.
#
#    You can redistribute and/or modify
#    this software under the terms of the
#    Creative Commons  Attribution-NonCommercial-ShareAlike 3.0 Legal Code
#
#    See COPYING file(s) join to the distribution and/or
#    http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
#
#############################

global PARAM

if {! [info exists PARAM(rep)]} {
set PARAM(rep) [info script]
set PARAM(rep) [file dirname $PARAM(rep)]
cd $PARAM(rep)
}
set PARAM(nomAppli) SoloCartes
set PARAM(nomLongAppli) "Jeux de cartes\nen solo"
set PARAM(verAppli) "v0.7"
set PARAM(dateVer) "28/11/2008"
set PARAM(vitesse) 1

source [file join "Lib" "Lib_fichiers.tcl"]

utiliseLibrairie "outils"

utiliseLibrairie "hasard"

global nbCartes
set nbCartes 0
global paquet
set paquet(indCarte,faceEnHaut) true
set paquet(indCarte) valeur
set paquet(indCarte,distribuee) false

global dosCartes
global dosDegrade
set dosDegrade(couleur1) "#0000ff"
set dosDegrade(couleur2) "#000000"
set dosDegrade(texte) "SoloCartes"
set dosDegrade(couleurTexte) "#ffffff"
global typeDosDegrade
set typeDosDegrade "nw"
global bordDegrade
set bordDegrade true

#set paquet(imgDos) [getImageCarte [file join "Img" "carteDosClassique - Bleu.png"]]
global indCarteDessusPaquet
set indCarteDessusPaquet 0

global jeuCourant
set jeuCourant ""

global jeuPrecedent
set jeuPrecedent ""


proc couleurRN {indCarte} {
  set coul [famillePCKT $indCarte]
  if {$coul == "K" || $coul == "C"} {
    return "R"
  } else {
    return "N"
  }
}

proc famillePCKT {indCarte} {
  global paquet

  if {$indCarte != ""} {
    return [string range $paquet($indCarte) end end]
  } else {
    return ""
  }
}

proc differenceCartes {ind1 ind2} {
  return [expr [valeurCarte $ind1] - [valeurCarte $ind2]]
}

proc valeurCarte {indCarte} {
  global paquet

  set val [string range $paquet($indCarte) 0 {end-1}]
  if {$val == "A"} {
    set val 1
  }
  if {$val == "V"} {
    set val 11
  }
  if {$val == "D"} {
    set val 12
  }
  if {$val == "R"} {
    set val 13
  }
  return [expr {int($val)}]
}

global REP_OPTIONS
set REP_OPTIONS [cheminComplet "Options"]
creerRep $REP_OPTIONS
global REP_MENUS
set REP_MENUS "Menus"
global REP_OUTILS
set REP_OUTILS "Outils"
global REP_SAUV
set REP_SAUV [cheminComplet "Sauvegardes"]
creerRep $REP_SAUV
global REP_STATS
set REP_STATS [cheminComplet "Statistiques"]
creerRep $REP_STATS
global REP_HIGHSCORES
set REP_HIGHSCORES [cheminComplet "HighScores"]
creerRep $REP_HIGHSCORES
global NOM_FIC_SAUV_AUTO
set NOM_FIC_SAUV_AUTO [file join $REP_SAUV "derniere.sauvauto"]

global txt

source "$PARAM(nomAppli)\_interface.tcl"

utiliseLibrairie "highscores"

utiliseLibrairie "statistiques"

global LISTE_EXT_SAUV
set LISTE_EXT_SAUV [list [list "$txt(TXT_SAVES)" {.sauv}]]

set joueurs(1,humain) true
set joueurs(1,score) ""
set joueurs(1,nom) "$txt(TXT_NOM_DEFAUT)"
catch {set joueurs(1,nom) "[lireFichier [file join $REP_OPTIONS "DernierJoueur.txt"]]"}

proc perdre {montant {joueur 1}} {
  global joueurs

  set joueurs($joueur,score) [expr {$joueurs($joueur,score) - $montant}]
  majAfficheScore
}

proc gagner {montant {joueur 1}} {
  global joueurs

  set joueurs($joueur,score) [expr {$joueurs($joueur,score) + $montant}]
  majAfficheScore
}


proc demandePrenom {} {
  global joueurs
  global couleurs
  global REP_OPTIONS
  global txt

  set saisie [inputBox [list " $txt(TXT_DDE_NOM) "] "$txt(TITRE_DDE_NOM)" [list "$joueurs(1,nom)"] $couleurs(DemandesFond)]
  if {[string trim $saisie " "] != ""} {
    set joueurs(1,nom) $saisie
    # On le sauvgarde dans le fichier du Dernier Joueur :
    ecrireFichier [file join $REP_OPTIONS "DernierJoueur.txt"] "$joueurs(1,nom)" 1
  } else {
    set saisie ""
  }
  return $saisie
}

global SCORE_DE_DEPART
set SCORE_DE_DEPART 0

proc partieEnCours {} {
  global joueurs
  global jeuCourant

  if {$joueurs(1,score) == "" || $jeuCourant == ""} {
    return false
  } else {
    return true
  }
}

global demanderSauvePartie
set demanderSauvePartie true
proc nouvellePartie {{nouvJeu ""}} {
  global jeuCourant
  global joueurs
  global jeuPrecedent
global couleurFond
global couleurScore
global demanderSauvePartie
global txt
  
  set rep "no"
  if {[partieEnCours] && $demanderSauvePartie} {
    set rep [msgBox "$txt(TXT_DDE_SAUV)" "$txt(TITRE_NVELLE_PARTIE)" "yesnocancel"]
#  if {$rep != "cancel"} {
    if {$rep == "yes"} {
      sauverPartie
    }
#  }
  }
#if {$nouvJeu != ""} {
#  set jeuCourant $nouvJeu
#}
  if {$rep != "cancel"} {
    afficherFrmAttente "" "" $couleurFond $couleurScore
    if {$nouvJeu != $jeuPrecedent && $nouvJeu != ""} {
      # on sauve les options du jeu PRECEDENT :
      sauverOptionsJeuPrecedent
      initPartie $nouvJeu
      source "$jeuCourant\.tcl"
    } else {
      if {$jeuCourant != ""} {
        # on sauve les options du jeu :
#        sauverOptionsJeuPrecedent ;# Mis en commentaire pour perfs depuis la v0.5. OK ?
        commencerPartie
      } else {
        msgBox "$txt(MSG_AUCUN_JEU)" "$txt(TITRE_NVELLE_PARTIE)" "ok" "warning"
        afficherFrame frmMenuPrincipal
      }
    }
#    commencerPartie $jeuCourant
  } else {
    set jeuCourant $jeuPrecedent
    chargerOptionsJeu
  }
}

proc proposerRejouer {} {
  global jeuCourant
  global joueurs
  global txt

  set rep [msgBox "$txt(TXT_DDE_REJOUE)" "$txt(TITRE_NVELLE_PARTIE)" "yesno"]
  if {$rep == "yes"} {
    commencerPartie
  } else {
    set joueurs(1,score) ""
    wm title . "SoloCartes"
    afficherFrame frmMenuPrincipal
  }
}

global scoresCumulatifs
set scoresCumulatifs false

proc initPartie {{nouvJeu ""} {nouvScore ""}} {
  global joueurs
  global jeuCourant
  global jeuPrecedent
  global PARAM
global scoresCumulatifs
global txt

effacerCoupAnnuler
if {$nouvScore != ""} {
  set joueurs(1,score) $nouvScore
} else {
  if {! $scoresCumulatifs || $joueurs(1,score) == ""} {
    set joueurs(1,score) 0
  }
}
  majAfficheScore

#  sauverOptions  ;# Mis en commentaire pour perfs depuis la v0.5. OK ? (en fait, pas de sauvegarde des options si plantage)
  if {$nouvJeu != ""} {
    set jeuCourant $nouvJeu
  }
  set jeuPrecedent $jeuCourant
  wm title . "$txt($jeuCourant\,NOM)"
  creerMenuChaine [subst [lireFichier "$PARAM(fichierMenu)"]]
}

#proc commencerPartie {{nouvJeu ""}} {
#  global jeuCourant

#  initPartie $nouvJeu
#  source "$jeuCourant\.tcl"
#}

proc melangerPaquet {{typePaquet "52Cartes.txt"}} {
  global nbCartes
  global paquet
  global dosCartes
  global garderPaquet
  global REP_OUTILS

if {! $garderPaquet} {
  initOutilsHasard
  set nbCartes 0
  majDosCartes
  set dosTmp $paquet(imgDos)
  unset paquet
  set paquet(imgDos) $dosTmp
  ajouterOutilHasard "jeu" [lireFichier [file join $REP_OUTILS "$typePaquet"]]
  set valeur [tirerOutilSansRemise 1]
  while {$valeur != ""} {
    incr nbCartes
    set paquet($nbCartes,faceEnHaut) false
    set paquet($nbCartes) $valeur
    set paquet($nbCartes,distribuee) false
    set valeur [tirerOutilSansRemise 1]
  }
} else {
  for {set i 1} {$i <= $nbCartes} {incr i} {
    set paquet($i,faceEnHaut) false
    set paquet($i,distribuee) false
  }
}
}

proc melangerPaquetListeCartes {listeCartes} {
  global nbCartes
  global paquet
  global dosCartes
  global garderPaquet

if {! $garderPaquet} {
  initOutilsHasard
  set nbCartes 0
  majDosCartes
  set dosTmp $paquet(imgDos)
  unset paquet
  set paquet(imgDos) $dosTmp
  ajouterOutilHasard "jeu" [liste2chaine $listeCartes "\n"]
  set valeur [tirerOutilSansRemise 1]
  while {$valeur != ""} {
    incr nbCartes
    set paquet($nbCartes,faceEnHaut) false
    set paquet($nbCartes) $valeur
    set paquet($nbCartes,distribuee) false
    set valeur [tirerOutilSansRemise 1]
  }
} else {
  for {set i 1} {$i <= $nbCartes} {incr i} {
    set paquet($i,faceEnHaut) false
    set paquet($i,distribuee) false
  }
}
}


global coutAnnuler
set coutAnnuler "" ;# si coutAnnuler vaut "", alors annuler est impossible

proc effacerCoupAnnuler {} {
  global coutAnnuler
  set coutAnnuler "" ;# si coutAnnuler vaut "", alors annuler est impossible
}

proc memoriserCoupAnnuler {{nbPointsPerdusSiAnnule 0}} {
  global LISTE_VARS_SAUV_PARTIE
  global coutAnnuler

  foreach variable $LISTE_VARS_SAUV_PARTIE {
    set indParenth [string first "(" $variable]
    if {$indParenth > 0} {
      set variableTab [string range $variable 0 [expr {$indParenth - 1}]]
      global $variableTab
      global $variableTab\_annuler
      catch {unset $variableTab\_annuler}
    } else {
      global $variable
      global $variable\_annuler
      catch {unset $variable\_annuler}
    }
    if {[array exists $variable]} {
      foreach nom [array names $variable] {
        set $variable\_annuler($nom) "[subst $[subst $variable]($nom)]"
      }
    } else {
      catch {
        set $variable\_annuler "[subst $[subst $variable]]"
      }
    }
  }
  set coutAnnuler $nbPointsPerdusSiAnnule
  if {"$coutAnnuler" == ""} {
    set coutAnnuler 0 ;# correction au cas o...
  }
}


proc annuler {} {
  global LISTE_VARS_SAUV_PARTIE
  global coutAnnuler
  global joueurs
  global txt

  if {"$coutAnnuler" != ""} {
    # OK !
    foreach variable $LISTE_VARS_SAUV_PARTIE {
      set indParenth [string first "(" $variable]
      if {$indParenth > 0} {
        set variableTab [string range $variable 0 [expr {$indParenth - 1}]]
        global $variableTab
        global $variableTab\_annuler
        set $variable "[subst $[subst $variable]_annuler([string range $variable [expr {$indParenth + 1}] end-1])]"
      } else {
        global $variable
        global $variable\_annuler
        if {[array exists $variable\_annuler]} {
          foreach nom [array names $variable\_annuler] {
            set $variable\($nom) "[subst $[subst $variable]_annuler($nom)]"
          }
        } else {
          set $variable "[subst $[subst $variable]_annuler]"
        }
      }
    }
#    initPartie $jeuCourant $joueurs(1,score)
#    set lanceAuto false
#    source "$jeuCourant\.tcl"
#    set lanceAuto true
#    chargerGlobales "$nomFic"
#set paquet(imgDos) ""
#if {"$dosCartes" != ""} {
#  set paquet(imgDos) [getImageCarte [file join "Img" "carteDos$dosCartes\.png"]]
#}
#    majDosCartes
perdre $coutAnnuler
    set scoreTmp $joueurs(1,score)
    majAfficheJeu
    set joueurs(1,score) $scoreTmp
    majAfficheScore
set coutAnnuler "" ;# On ne pourra plus annuler
afficherFrame frmJeu

  } else {
    msgBox $txt(MSG_IMP_ANNULER) $txt(TITRE_ANNULER)
  }
}



global NOM_FIC_OPTIONS
set NOM_FIC_OPTIONS [file join $REP_OPTIONS "Options.ini"]
global LISTE_VARS_OPTIONS
set LISTE_VARS_OPTIONS [list langueAffichage clavierAuto couleurFond couleurScore dosCartes jeuCourant scoresCumulatifs joueurs fixeTapis demanderSauvePartie dosDegrade typeDosDegrade bordDegrade]
global LISTE_VARS_OPTIONS_JEU
set LISTE_VARS_OPTIONS_JEU [list]
proc chargerOptions {} {
  global NOM_FIC_OPTIONS
#  global PARAM
  global couleurFond
  global couleurScore
  global langueAffichage

  if {[file exists $NOM_FIC_OPTIONS]} {
    chargerGlobales $NOM_FIC_OPTIONS
    setLangueAffichage $langueAffichage
  }
  changerCouleurFond $couleurFond
  changerCouleurScore $couleurScore
}
proc sauverOptions {} {
  global NOM_FIC_OPTIONS
  global LISTE_VARS_OPTIONS

  sauverGlobales $NOM_FIC_OPTIONS $LISTE_VARS_OPTIONS
  sauverOptionsJeuPrecedent
}

catch {chargerOptions}

proc chargerOptionsJeu {} {
  global jeuCourant
  global REP_OPTIONS

  set nomFicOptionsJeu [file join $REP_OPTIONS "$jeuCourant\.ini"]
  if {[file exists $nomFicOptionsJeu]} {
#msgBox "Charge options $jeuCourant"
    chargerGlobales $nomFicOptionsJeu
  }
}

proc sauverOptionsJeuPrecedent {} {
  global jeuPrecedent
  global LISTE_VARS_OPTIONS_JEU
  global REP_OPTIONS

  if {[llength $LISTE_VARS_OPTIONS_JEU] > 0 && $jeuPrecedent != ""} {
    set nomFicOptionsJeu [file join $REP_OPTIONS "$jeuPrecedent\.ini"]
#msgBox "sauve options $jeuPrecedent"
    sauverGlobales $nomFicOptionsJeu $LISTE_VARS_OPTIONS_JEU
  }
}

proc verifierScore {} {
  global joueurs
  global highScores
global scoresCumulatifs
global txt

  if {$joueurs(1,score) > 0} {
    set commentaire ""
if {$scoresCumulatifs} {
  set commentaire "$txt(TXT_CUMUL)"
}
    set nouveau [nouveauHighScore? "" $joueurs(1,score) "$commentaire"]
    if {$nouveau >= 1} {
      if {$nouveau == 1} {
        msgBox "$txt(MSG_MEILL_SCORE)" "$txt(TITRE_MEILL_SCORE)"
      } else {
        msgBox "$txt(MSG_ENTRE_SCORE)" "$txt(TITRE_ENTRE_SCORE)"
      }
      set highScores($nouveau,nom) [demandePrenom]
      sauverHighScores
      afficherScoresJeuCourant
    }
  }
}


proc quitterPartie {} {
  global txt

  set rep [msgBox "$txt(TXT_DDE_SAUV)" "$txt(TITRE_QUIT)" "yesnocancel"]
  if {$rep != "cancel"} {
    if {$rep == "yes"} {
      sauverPartie
    }
    quitter
  }
}

proc quitter {} {
  global PARAM
  global REP_SAUV
global NOM_FIC_SAUV_AUTO

#set ficAuto "[file join $REP_SAUV $NOM_FIC_SAUV_AUTO]"
  if {[partieEnCours]} {
#msgBox "$ficAuto"
    sauverPartie $NOM_FIC_SAUV_AUTO true
  } else {
#msgBox "!encours"
catch {file delete -force $NOM_FIC_SAUV_AUTO}
  }
  sauverOptions
  exit
}

wm protocol . WM_DELETE_WINDOW {quitter}

proc quitterJeu {} {
  global PARAM

  afficherFrame frmMenuPrincipal
  creerMenuFichier "$PARAM(menu)"
}

global LISTE_VARS_SAUV_PARTIE
set LISTE_VARS_SAUV_PARTIE [list]

proc sauverPartie {{nomFic ""} {rapide false}} {
  global PARAM
  global LISTE_EXT_SAUV
  global LISTE_VARS_SAUV_PARTIE
  global REP_SAUV
  global txt
  
  if {[partieEnCours]} {
    set ext [lindex [lindex $LISTE_EXT_SAUV 0] 1]
    if {$nomFic == ""} {
      catch {file mkdir "$REP_SAUV"}
      set nomFic [tk_getSaveFile -filetypes $LISTE_EXT_SAUV -defaultextension $ext -initialdir $REP_SAUV -title "$txt(TITRE_SAUVE)"]
      if {$nomFic != ""} {
        set REP_SAUV [file dirname "$nomFic"]
      }
      set longExt [expr {[string length $ext] - 1}]
      if {"[string tolower [string range $nomFic end-$longExt end]]" != "$ext"} {
        append nomFic "$ext"
      }
    }
    if {$nomFic != "$ext"} {
      set listeSauve $LISTE_VARS_SAUV_PARTIE
      lappend listeSauve joueurs jeuCourant scoresCumulatifs ;# dosDegrade typeDosDegrade
      sauverGlobales "$nomFic" $listeSauve
      if {! $rapide} {
        msgBox "$txt(MSG_SAUVE)" "$txt(TITRE_SAUVE)"
      }
    }
  } else {
    msgBox "$txt(MSG_PAS_PARTIE)" "$txt(TITRE_SAUVE)"
  }
}

if {! [globaleExiste lanceAuto]} {
  global lanceAuto
  set lanceAuto true
}

global SoloCartes
set SoloCartes true

proc chargerPartie {{nomFic ""}} {
  global joueurs
  global jeuCourant
  global PARAM
  global LISTE_EXT_SAUV
  global REP_SAUV
  global lanceAuto
  global paquet
  global dosCartes
  global txt

  if {$nomFic == ""} {
    set nomFic [tk_getOpenFile -filetypes $LISTE_EXT_SAUV -initialdir $REP_SAUV -title "$txt(TITRE_CHARGE)"]
  }
  if {$nomFic != ""} {
    chargerGlobales "$nomFic"
if {$jeuCourant == "Tours de Hanoi"} {set jeuCourant "ToursHanoi"}
if {$jeuCourant == "Memory ordre"} {set jeuCourant "MemoryOrdre"}
if {$jeuCourant == "Entre deux"} {set jeuCourant "EntreDeux"}

#majDosCartes
#    set paquet(imgDos) [getImageCarte [file join "Img" "carteDos$dosCartes\.png"]]
    initPartie $jeuCourant $joueurs(1,score)
    set lanceAuto false
    source "$jeuCourant\.tcl"
    set lanceAuto true
    chargerGlobales "$nomFic"
set paquet(imgDos) ""
if {"$dosCartes" != ""} {
  set paquet(imgDos) [getImageCarte [file join "Img" "carteDos$dosCartes\.png"]]
}
    majDosCartes
    set scoreTmp $joueurs(1,score)
    majAfficheJeu
    set joueurs(1,score) $scoreTmp
    majAfficheScore
afficherFrame frmJeu
  }
}

global garderPaquet
set garderPaquet false
proc recommencerPartie {} {
  global garderPaquet

  set garderPaquet true
  nouvellePartie
  set garderPaquet false
}

proc msgAideJeu {} {
  global nbJoueurs
#  global msgAide
  global jeuCourant
  global txt

  set msgAide ""
  catch {set msgAide $txt($jeuCourant\,AIDE)}
  if {"$msgAide" == ""} {
    set msgAide "$txt(MSG_PAS_AIDE)"
  }
  msgBox "$msgAide" "$txt(TITRE_AIDE)"
}

if {$jeuCourant == "Tours de Hanoi"} {set jeuCourant "ToursHanoi"}
if {$jeuCourant == "Memory ordre"} {set jeuCourant "MemoryOrdre"}
if {$jeuCourant == "Entre deux"} {set jeuCourant "EntreDeux"}
initAfficheMenuPrincipal
if {! [globaleExiste initJeux]} {
#  set ficAuto "[file join $REP_SAUV $NOM_FIC_SAUV_AUTO]"
  if {[file exists $NOM_FIC_SAUV_AUTO]} {
    chargerPartie $NOM_FIC_SAUV_AUTO
  } else {
    if {$jeuCourant != ""} {
      nouvellePartie $jeuCourant
    } else {
      source "SoloCartes_initJeux.tcl"
      afficherFrame frmMenuPrincipal
    }
  }
}
#logDebug "fin du chargement total"
