#############################
#
#          SoloCartes
#
# Copyright 2008 Newmagic
#
#    This file is part of SoloCartes.
#
#    You can redistribute and/or modify
#    this software under the terms of the
#    Creative Commons  Attribution-NonCommercial-ShareAlike 3.0 Legal Code
#
#    See COPYING file(s) join to the distribution and/or
#    http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
#
#############################

global PARAM

set PARAM(rep) [info script]
set PARAM(rep) [file dirname $PARAM(rep)]
cd $PARAM(rep)

source "SoloCartes_initJeux.tcl"

global difficulte
set difficulte "difficile" ;# ou "normale" ou "facile"

global facesEnHaut
set facesEnHaut false

global LISTE_VARS_OPTIONS_JEU
set LISTE_VARS_OPTIONS_JEU [list difficulte facesEnHaut]

global LISTE_VARS_SAUV_PARTIE
set LISTE_VARS_SAUV_PARTIE [list paquet depots colonnes nbColonnes nbCartes difficulte facesEnHaut]

global jeuCourant
set jeuCourant Spider
chargerOptionsJeu


proc valeurAfficheePourCarte {valCarte} {
  global difficulte

  if {$difficulte == "facile"} {
    set valCarte "[string range $valCarte 0 end-1]P"
  }
  if {$difficulte == "normale"} {
    set famille [string range $valCarte end end]
    if {$famille == "T"} {
      set valCarte "[string range $valCarte 0 end-1]P"
    }
    if {$famille == "K"} {
      set valCarte "[string range $valCarte 0 end-1]C"
    }
  }
  return "$valCarte"
}

proc montrerCarte {indCarte {faceEnHaut true}} {
  global paquet
  global imageCarte

  if {$faceEnHaut} {
#    if {! [info exists "imageCarte($paquet($indCarte))"]} {
        set imageCarte($paquet($indCarte)) [getImageCarte [nomFicImgCarte $paquet($indCarte)]]
#    }
    set valAffichee [valeurAfficheePourCarte $paquet($indCarte)]
#    if {! [info exists "imageCarte($valAffichee)"]} {
      set imageCarte($valAffichee) [getImageCarte [nomFicImgCarte $valAffichee]]
#    }
    changerImage $indCarte $imageCarte($valAffichee)
  } else {
    changerImage $indCarte $paquet(imgDos)
  }
}


proc colSousXY {x y} {
  return [colSousPourcXY [pourcCoordX $x] [pourcCoordY $y]]
}

proc colSousPourcXY {pourcX pourcY} {
  global nbColonnes
  global colonnes
  global largImages
  global PAQUET_POURC_Y
  global hautImages

#  if {$pourcY >= [expr {$PAQUET_POURC_Y * 2 + $hautImages}]}
  if {$pourcY >= [expr {$PAQUET_POURC_Y * 2}]} {
    set continuer true
    set i 0
    set minCarte $pourcX
#    set maxCarte [expr {$pourcX + [pourcCoordX $largImages]}]
    set maxCarte [expr {$pourcX + $largImages}]
    set milieuCarte [expr {$minCarte + (($maxCarte - $minCarte) / 2)}]
    set colDroite -1
    set colGauche -1
    set distGauche -1
    set distDroite -1

#msgBox "$pourcX [pourcCoordX $largImages] => $milieuCarte"
    while {$continuer} {
      incr i
      if {$i <= $nbColonnes} {
        set minCol $colonnes($i,posX)
        if {$minCol > $maxCarte} {
          # ca sert  rien d'aller + loin
          set continuer false
        }
        if {$continuer} {
#          set maxCol [expr {$minCol + [pourcCoordX $largImages]}]
          set maxCol [expr {$minCol + $largImages}]
          if {$minCarte >= $minCol && $minCarte <= $maxCol} {
            set colGauche $i
#            set distGauche [expr {$maxCol - $minCarte}]
            set distGauche [expr {$maxCarte - $minCol}]
          }
          if {$maxCarte >= $minCol && $maxCarte <= $maxCol} {
            set colDroite $i
#            set distDroite [expr {$maxCarte - $minCol}]
            set distDroite [expr {$maxCol - $minCarte}]
          }
        }
      } else {
        set continuer false
      }
    }
    set indCol $colGauche
    if {$colGauche > 0 && $colDroite > 0} {
      # on regarde le plus prs :
      if {$distGauche > $distDroite} {
        set indCol $colDroite
      }
    }
    if {$indCol == -1} {
      set indCol $colDroite
    }
    return $indCol
  } else {
    return -1
  }
}

global paquet

global nbColonnes
set nbColonnes 0

global colonnes
set colonnes(ind,posX) pourc
set colonnes(ind,listeCartes) [list]

global depots
set depots(ind,listeCartes) [list]


proc attraperCarte {indCarte x y} {
  global indCarteDragguee
  global indCarteDraggueeTmp
  global diffX
  global diffY
  global imgCartes
  global paquet
  global x_initDrag
  global y_initDrag
  global colonnes
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global largImages
  global nbCartes

  set liste [.frmJeu.cnv coords $imgCartes($indCarte)]
  set x_carte [lindex $liste 0]
  set y_carte [lindex $liste 1]
  if {$paquet($indCarte,distribuee)} {
    if {$paquet($indCarte,faceEnHaut)} {
      if {[carteSurCol $indCarte]} {
        set indCarteDraggueeTmp $indCarte
        .frmJeu.cnv raise Carte$indCarteDraggueeTmp
        set x_initDrag $x_carte
        set y_initDrag $y_carte
        set diffX [expr {$x - $x_initDrag}]
        set diffY [expr {$y - $y_initDrag}]
      }
    } else {
      # elle est  l'envers => on retourne face en haut
      # la dernire de la colonne :
      set indCol [colSousXY $x_carte $y_carte]
      if {$indCol > 0} {
        set derniere [lindex $colonnes($indCol,listeCartes) end]
        if {! $paquet($derniere,faceEnHaut)} {
          retournerCarte $derniere
        }
      }
    }
  } else {
   if {[pourcCoordX $x_carte] == $PAQUET_POURC_X && [pourcCoordY $y_carte] == $PAQUET_POURC_Y} {
      # clic sur paquet
      distribuer
    }
  }
}

proc distribuer {} {
  global paquet
  global nbColonnes
  global nbCartes

  set indDerniereCarteDistribuee 40
  set continuer true
  while {$continuer} {
    if {!$paquet($indDerniereCarteDistribuee,distribuee)} {
      set continuer false
    } else {
      incr indDerniereCarteDistribuee
      if {$indDerniereCarteDistribuee > $nbCartes} {
        set continuer false
        set indDerniereCarteDistribuee -1
      }
    }
  }
  if {$indDerniereCarteDistribuee > 0} {
    set indCol 1
    while {$indDerniereCarteDistribuee <= $nbCartes && $indCol <= $nbColonnes} {
      distribuerCarteSurColonne $indDerniereCarteDistribuee $indCol
      retournerCarte $indDerniereCarteDistribuee
      update idletasks
      incr indDerniereCarteDistribuee
      incr indCol
    }  
effacerCoupAnnuler
  }
}

proc lacherCarte {} {
  global indCarteDragguee
  global indCarteDraggueeTmp
  global imgCartes
  global diffX
  global diffY
  global x_initDrag
  global y_initDrag
  global colonnes
  global paquet
  global nbColonnes
  global depots
  global difficulte
  global txt

  set diffX 0
  set diffY 0
  if {$indCarteDraggueeTmp > 0} {
    set indCarteDragguee $indCarteDraggueeTmp
    set deplaceOk false
    set indCarte $indCarteDragguee
    set liste [.frmJeu.cnv coords $imgCartes($indCarte)]
    set x [lindex $liste 0]
    set y [lindex $liste 1]
    set indCol [colSousXY $x $y]

    if {$indCol > 0} {
      # rgles
      set reglesOk false
      set indAncienneCol [colSousXY $x_initDrag $y_initDrag]
      if {$indAncienneCol > 0 && $indAncienneCol != $indCol} {
        set nbCartesSurCol [llength $colonnes($indCol,listeCartes)]
        if {$nbCartesSurCol > 0} {
          set derniereCarteCol [lindex $colonnes($indCol,listeCartes) end] ;#[expr {$nbCartesSurCol - 1}]]
          if {[differenceCartes $derniereCarteCol $indCarte] == 1} {
            set reglesOk true
          }
        } else {
#        if {[string range $paquet($indCarte) 0 0] == "R"} {
#          # roi => ok
            set reglesOk true
#        }
        }
      }
      if {$reglesOk} {
        if {$indAncienneCol > 0} {
#          if {$indAncienneCol != $indCol} {
            perdre 1
#          }
memoriserCoupAnnuler 1
          set indDansAncienneCol [lsearch $colonnes($indAncienneCol,listeCartes) $indCarte]
          set long [llength $colonnes($indAncienneCol,listeCartes)]
          for {set i $indDansAncienneCol} {$i < $long} {incr i} {
            distribuerCarteSurColonne [lindex $colonnes($indAncienneCol,listeCartes) $i] $indCol
          }
          for {set i $indDansAncienneCol} {$i < $long} {incr i} {
            enleverDerniereCarteCol $indAncienneCol
          }
          set indDepotLibre -1
          set nbCartesSurCol [llength $colonnes($indCol,listeCartes)]
          if {$nbCartesSurCol >= 13 && [valeurCarte [lindex $colonnes($indCol,listeCartes) end]] == 1} {
            # la colonne se termine par un as : on remonte jusqu'en haut pour voir si la liste est complte :
            set i $nbCartesSurCol
            incr i -1
            set ok true
            set continuer true
            while {$continuer} {
              set indCarteCour [lindex $colonnes($indCol,listeCartes) [expr {$i + 0}]]
              set indCartePrec [lindex $colonnes($indCol,listeCartes) [expr {$i - 1}]]
              #msgBox "$i $indCarteSuiv"
              if {[differenceCartes $indCartePrec $indCarteCour] != 1 || ! $paquet($indCartePrec,faceEnHaut)} {
                set ok false
              } else {
                if {$difficulte == "normale" && [couleurRN $indCarteCour] != [couleurRN $indCartePrec]} {
                  # ca passe pas...
                  set ok false
                }
                if {$difficulte == "difficile" && [famillePCKT $indCarteCour] != [famillePCKT $indCartePrec]} {
                  # ... et l non plus !
                  set ok false
                }
              }
              if {! $ok} {
                set continuer false
              } else {
                incr i -1
                if {$i < 0} {
                  set continuer false
                } else {
                  if {$i <= [expr {$nbCartesSurCol - 13}]} {
                    set continuer false
                  }
                }
              }
            }
            if {$ok} {
              # ok => on remonte la pile dans un dpt :
              set continuer true
              set indDepotLibre 1
              while {$continuer} {
                if {[llength $depots($indDepotLibre,listeCartes)] == 0} {
                  set continuer false
                } else {
                  incr indDepotLibre
                  if {$indDepotLibre > 8} {
                    set indDepotLibre -1
                    set continuer false
                  }
                }
              }
              if {$indDepotLibre > 0} {
                for {set i 0} {$i < 13} {incr i} {
                  distribuerCarteSurDepot [lindex $colonnes($indCol,listeCartes) end] $indDepotLibre
                  enleverDerniereCarteCol $indCol
                update idletasks
                }
                gagner 100
              }
effacerCoupAnnuler
            }
          }
          if {[llength $colonnes($indCol,listeCartes)] > 0} {
            set indDernCarte [lindex $colonnes($indCol,listeCartes) end]
            if {! $paquet($indDernCarte,faceEnHaut)} {
              retournerCarte $indDernCarte
            }
          }
          if {[llength $colonnes($indAncienneCol,listeCartes)] > 0} {
            set indDernCarte [lindex $colonnes($indAncienneCol,listeCartes) end]
            if {! $paquet($indDernCarte,faceEnHaut)} {
              retournerCarte $indDernCarte
            }
          } else {
            if {$indDepotLibre == 8} {
              verifierScore
              incrementerStats "$txt(STAT_NB_GAGNE)"
              proposerRejouer
            }
          }
          set deplaceOk true
        } else {
          # Elle vient d'ailleurs (paquet ou dpt)
          # => non autoris
        }
      }
    }
    if {!$deplaceOk} {
      # on la replace o elle tait
      deplacerCarteDraguee $x_initDrag $y_initDrag
    }
  }
  set indCarteDragguee -1
  set indCarteDraggueeTmp -1
  global lstCartesSousDraguee
  set lstCartesSousDraguee [list]
}

global lstCartesSousDraguee
set lstCartesSousDraguee [list]

proc deplacerCarteDraguee {x y} {
  global indCarteDragguee
  global indCarteDraggueeTmp
  global x_initDrag
  global y_initDrag
  global colonnes
  global paquet
  global difficulte
  global lstCartesSousDraguee

  if {$indCarteDragguee > 0} {
    set ok false
    if {[llength $lstCartesSousDraguee] == 0} {
      # on regarde si toutes les cartes dessous vrifient bien les rgles :
      set indCol [colSousXY $x_initDrag $y_initDrag]
      if {$indCol > 0} {
        set indDansCol [lsearch $colonnes($indCol,listeCartes) $indCarteDragguee]
        incr indDansCol
        if {$indDansCol > 0} {
          set i $indDansCol
          set ok true
          set continuer true
          if {$i >= [llength $colonnes($indCol,listeCartes)]} {
            set continuer false
          }
          while {$continuer} {
            set indCarteSuiv [lindex $colonnes($indCol,listeCartes) $i]
#msgBox "$i $indCarteSuiv"
#msgBox "[expr {$i-$indDansCol+1}]"
            if {[differenceCartes $indCarteDragguee $indCarteSuiv] != [expr {$i-$indDansCol+1}]} {
              set ok false
            }
            if {$difficulte == "normale" && [couleurRN $indCarteSuiv] != [couleurRN $indCarteDragguee]} {
              # ca passe pas...
              set ok false
            }
            if {$difficulte == "difficile" && [famillePCKT $indCarteSuiv] != [famillePCKT $indCarteDragguee]} {
              # ... et l non plus !
              set ok false
            }
            if {! $ok} {
              set continuer false
            } else {
              incr i
              if {$i >= [llength $colonnes($indCol,listeCartes)]} {
                set continuer false
              }
            }
          }
          if {$ok} {
            set lstCartesSousDraguee [lrange $colonnes($indCol,listeCartes) $indDansCol end]
          } else {
            for {set i $indDansCol} {$i < [llength $colonnes($indCol,listeCartes)]} {incr i} {
              .frmJeu.cnv raise "Carte[lindex $colonnes($indCol,listeCartes) $i]"
            }
          }
        }
      }
    } else {
      set ok true
    }
    if {$ok} {
      set yDessus $y
      deplacerCarte $indCarteDragguee $x $y
      # on prend toutes celles qui sont dessous ET QUI REPONDENT AUX REGLES :
      foreach i $lstCartesSousDraguee {
        set diff [coordY [expr 3]]
        set yDessus [expr {$diff + $yDessus}]
        deplacerCarte $i $x $yDessus
      }
    }
  } else {
    set diffX [expr {$x - $x_initDrag}]
    if {$diffX < 0} {set diffX [expr {0 - $diffX}]}
    set diffY [expr {$y - $y_initDrag}]
    if {$diffY < 0} {set diffY [expr {0 - $diffY}]}
    set diffActive 50
    #msgBox "$diffX $diffY"
    if {$diffX > $diffActive || $diffY > $diffActive} {
      set indCarteDragguee $indCarteDraggueeTmp
    }
  }
}


proc bindingsCarte {indCarte} {
  global imgCartes

  .frmJeu.cnv bind $imgCartes($indCarte) <ButtonPress-1> "attraperCarte $indCarte %X %Y"
  .frmJeu.cnv bind $imgCartes($indCarte) <ButtonRelease-1> "lacherCarte"
  .frmJeu.cnv bind $imgCartes($indCarte) <Motion> {deplacerCarteDraguee %X %Y}

  #.frmJeu.cnv bind $imgCartes($indCarte) <Double-ButtonPress-1> "chercherDepotPourCarte $indCarte %X %Y"

}

proc carteSurCol {indCarte} {
  global colonnes
  global nbColonnes
  global depots

  set continuer true
  set trouve false
  set indCol 1
  while {$continuer} {
    if {[lsearch $colonnes($indCol,listeCartes) $indCarte] >= 0} {
      set continuer false
      set trouve true
    }
    if {$continuer} {
      incr indCol
      if {$indCol > $nbColonnes} {
        set continuer false
      }
    }
  }
  return $trouve
}

proc initColonnes {nb} {
  global nbColonnes
  global colonnes
  global hautImages
  global largImages
  global PAQUET_POURC_Y
  global depots

  unset colonnes
  set nbColonnes $nb
  set espaceEntreCol [expr {(100 - ($nbColonnes * $largImages)) / ($nbColonnes + 1)}]

  for {set i 1} {$i <= $nbColonnes} {incr i} {
    set colonnes($i,listeCartes) [list]
    set colonnes($i,posX) [expr {($espaceEntreCol * $i) + ($largImages * ($i - 1))}]
    tracerRectangleCarte "col$i" [coordX $colonnes($i,posX)] [coordY [expr {$PAQUET_POURC_Y * 2 + $hautImages}]]
  }
  # on en profite pour calculer les "dpts" :
  set indDepot 1
  for {set i [expr {$nbColonnes - 7}]} {$i <= $nbColonnes} {incr i} {
    tracerRectangleCarte "depot$indDepot" [coordX $colonnes($i,posX)] [coordY $PAQUET_POURC_Y]
    set depots($indDepot,listeCartes) [list]
    incr indDepot
  }
}

proc distribuerCartes {} {
  global nbColonnes
  global indDerniereCarteDistribuee
  global typeScore
  global colonnes
  global facesEnHaut

  set indCol 1
  for {set indCarte 1} {$indCarte <= 44} {incr indCarte} {
    distribuerCarteSurColonne $indCarte $indCol
    if {$facesEnHaut} {
      retournerCarte $indCarte
    }
    incr indCol
    if {$indCol > $nbColonnes} {
      set indCol 1
    }
  }

  if {! $facesEnHaut} {
    for {set i 1} {$i <= $nbColonnes} {incr i} {
      retournerCarte [lindex $colonnes($i,listeCartes) end]
    }
  }
  # gagner 500
}

proc deplacerCarteSurColonne {indCarte indColonne rang {avecAnimation false}} {
  global colonnes
  global paquet
  global PAQUET_POURC_Y
  global hautImages

  set yPourc [expr {$PAQUET_POURC_Y * 2 + $hautImages + 3 * $rang}]
  deplacerCarte $indCarte [coordX $colonnes($indColonne,posX)] [coordY $yPourc] $avecAnimation
}

# On distribue la carte indCarte sur le dpt indDepot
proc distribuerCarteSurDepot {indCarte indDepot} {
#  global colonnes
#  global nbColonnes
  global depots
  global paquet
#  global PAQUET_POURC_Y
#  global hautImages
#  global typeScore
#  global joueurs
#  global highScores

  deplacerCarteSurDepot $indCarte $indDepot
  lappend depots($indDepot,listeCartes) $indCarte
  set paquet($indCarte,distribuee) true
}

proc deplacerCarteSurDepot {indCarte indDepot} {
  global colonnes
  global nbColonnes
  global PAQUET_POURC_Y

  set indColonne [expr {$nbColonnes - 8 + $indDepot}]
  deplacerCarte $indCarte [coordX $colonnes($indColonne,posX)] [coordY $PAQUET_POURC_Y]
  update idletasks
}

proc termine {} {
}


proc initScoresStats {} {
global jeuCourant
  global nbCartes
  global difficulte
  global facesEnHaut
  global typeScore
global titreScores
  global REP_HIGHSCORES
  global REP_STATS
  global txt
  
if {$difficulte == "facile"} {
set titreScores "$txt($jeuCourant\,NOM) - 1 $txt(Spider,TXT_FAMILLE)"
}
if {$difficulte == "normale"} {
set titreScores "$txt($jeuCourant\,NOM) - 2 $txt(Spider,TXT_FAMILLES)"
}
if {$difficulte == "difficile"} {
set titreScores "$txt($jeuCourant\,NOM) - 4 $txt(Spider,TXT_FAMILLES)"
}
  set nomFicScores "$jeuCourant\_$difficulte"
  if {$facesEnHaut} {
    append titreScores "\n$txt(TXT_CARTES_VISIBLES)"
    append nomFicScores "_visibles"
  }
  chargerHighScores [file join $REP_HIGHSCORES "$nomFicScores\.txt"]
  chargerStats [file join $REP_STATS "$jeuCourant\.txt"]
}

proc majAfficheJeu {} {
  global colonnes
  global nbColonnes
  global depots
  global paquet
  global nbCartes
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global hautImages
  global difficulte
  global facesEnHaut
  global jeuCourant

initScoresStats
  initAffichage
#msgBox "$dernDistrib"

  set PAQUET_POURC_X 5
  set PAQUET_POURC_Y 2
  tracerRectangleCarte "paquet" [coordX $PAQUET_POURC_X] [coordY $PAQUET_POURC_Y]
# .frmJeu.cnv bind paquet <ButtonPress-1> "rempilerPaquet"
  for {set i $nbCartes} {$i >= 1} {incr i -1} {
    placerCarte $i $PAQUET_POURC_X $PAQUET_POURC_Y [expr {! $paquet($i,faceEnHaut)}]
  }

#  initColonnes $nbColonnes
  for {set i 1} {$i <= $nbCartes} {incr i} {
    set paquet($i,distribuee) false
  }
#msgBox "$nbColonnes"
  for {set i 1} {$i <= $nbColonnes} {incr i} {
    tracerRectangleCarte "col$i" [coordX $colonnes($i,posX)] [coordY [expr {$PAQUET_POURC_Y * 2 + $hautImages}]]
    set rang 0
#msgBox "$i : $colonnes($i,listeCartes)"
    foreach indCarte $colonnes($i,listeCartes) {
      set paquet($indCarte,distribuee) true
      set faceEnHaut($indCarte) $paquet($indCarte,faceEnHaut)
#    placerCarte $indCarte 110 110 true
      deplacerCarteSurColonne $indCarte $i $rang
      set paquet($indCarte,faceEnHaut) $faceEnHaut($indCarte)
      montrerCarte $indCarte $paquet($indCarte,faceEnHaut)
      incr rang
    }
  }
  for {set i 1} {$i <= 8} {incr i} {
    set indCol [expr {$i + $nbColonnes - 8}]
    tracerRectangleCarte "depot$i" [coordX $colonnes($indCol,posX)] [coordY $PAQUET_POURC_Y]
    foreach indCarte $depots($i,listeCartes) {
      set paquet($indCarte,distribuee) true
#set faceEnHaut($indCarte) $paquet($indCarte,faceEnHaut)
#    placerCarte $indCarte 110 110 true
      deplacerCarteSurDepot $indCarte $i
# set paquet($indCarte,faceEnHaut) $faceEnHaut($indCarte)  
      montrerCarte $indCarte true
    }
  }
  update
}

proc commencerPartie {} {
  global joueurs
  global SCORE_DE_DEPART
  global difficulte
  global REP_HIGHSCORES
  global REP_STATS
global jeuCourant
  global titreScores
  global facesEnHaut
  global txt

  initPartie $jeuCourant
  initScoresStats
  initAffichage
  melangerPaquet "2x52Cartes.txt"
  placerPaquet 5 2
  initColonnes 10
  distribuerCartes
  majAfficheScore
  afficherFrame frmJeu
  incrementerStats "$txt(STAT_NB_PARTIES)"
}

global lanceAuto
if {$lanceAuto} {
commencerPartie
}